#include <stdio.h>
#define M 6
#define N 4

char matr [ M ][ N ] = {{ 0xef , 0x86, 0x57 , 0x36 } ,
			{ 0x7f , 0x38, 0xe0 , 0x6e } ,
			{ 0x17 , 0x2f, 0xf0 , 0x50 } ,
			{ 0x70 , 0x20, 0x60 , 0xcb } ,
			{ 0x70 , 0x78, 0xfc , 0xe2 } ,
			{ 0x56 , 0x10, 0xf6 , 0x28 } } ;

int check ( int i, int j, int k, int m )
{
	int ii , jj ;
	for ( ii = 0; ii < k ; ii ++ )
	for ( jj = 0; jj < m ;  jj ++ )
		if ( matr [ i + ii ][ ( j + jj ) / 8 ] & 1 << ( j + jj ) % 8 ) 
			return 0 ;
	return 1 ;
}

void main ( )
{
	int i, j, k, m,  maxArea = 0 , startI ,startJ, sizeI, sizeJ;

	for ( i = 0 ; i < M ; i ++ )
		for ( j = 0 ; j < N * 8  ; j ++ )
			for ( k = 1 ; k <= M - i ; k ++ )
				for ( m = ( maxArea + 1 ) / k ; m <= N * 8 - j ; m ++ )
					if ( check ( i, j , k , m ) &&
					      k * m > maxArea ) {
						maxArea = k * m;
						startI = i ;
						startJ = j ;
						sizeI = k ;
						sizeJ = m ;
					}
	printf ( "From ...[ %d ][ %d ], bit %d , Size { %d , %d } : Area %d" ,
	      startI ,startJ / 8, startJ % 8, sizeI, sizeJ , maxArea );
}
