// BacteriumView.cpp : implementation of the CBacteriumView class
//

#include "stdafx.h"
#include "Bacterium.h"

#include "BacteriumDoc.h"
#include "BacteriumView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBacteriumView

IMPLEMENT_DYNCREATE(CBacteriumView, CView)

BEGIN_MESSAGE_MAP(CBacteriumView, CView)
	//{{AFX_MSG_MAP(CBacteriumView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBacteriumView construction/destruction

CBacteriumView::CBacteriumView()
{
	// TODO: add construction code here
		int i, j ;
	for ( i = 0 ; i < 480; i ++ )
		for ( j = 0 ; j < 80 ; j ++ )
			matr [ i ][ j ] = 0;

	for ( i = 1 ; i < 480; i ++ )
		for ( j = 1 ; j < 640 ; j ++ )
			if ( ( rand ( ) & 7 ) == 1 )
				matr [ i ][ j >> 3 ] |= 0x1 << ( j & 7 ) ;

}

CBacteriumView::~CBacteriumView()
{
}

BOOL CBacteriumView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBacteriumView drawing

void CBacteriumView::OnDraw(CDC* pDC)
{
	CBacteriumDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CBacteriumView diagnostics

#ifdef _DEBUG
void CBacteriumView::AssertValid() const
{
	CView::AssertValid();
}

void CBacteriumView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBacteriumDoc* CBacteriumView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBacteriumDoc)));
	return (CBacteriumDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBacteriumView message handlers

int CBacteriumView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	SetTimer ( 1, 1, 0 );
	return 0;
}

void CBacteriumView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer ( 1 );
}

void CBacteriumView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc ( this ) ;

	// TODO: Add your message handler code here and/or call default
	int i,j, temp ;
	for ( i = 1 ; i < 480 ; i ++ )
		for ( j = 1 ; j < 640 ; j ++ )
			if ( counter ( i, j ) == 3 )  {
				matr [ i ][ j >> 3 ] |= 0x1 << ( j & 7 );
				dc.SetPixel ( j , i , RGB ( 0,0,0) );
				}

	for ( i = 1 ; i < 480 ; i ++ )
		for ( j = 1 ; j < 640 ; j ++ ) 	{
			temp = counter ( i , j ) ;
			if ( temp > 1 && temp < 5 )
				continue;
			matr [ i ][ j >> 3 ] &=  ~ ( 0x1 << ( j & 7 ) ) ;
			dc.SetPixel ( j , i , RGB ( 255 , 255  , 255 ) ) ;
		}
	
	CView::OnTimer(nIDEvent);
}
int CBacteriumView::counter ( int i , int j )
{
	int k , m , result = 0 ;
	for ( k = j - 1 ; k <= j + 1 ; k ++ )
		for ( m = i - 1 ; m <= i + 1 ; m ++ ) {
			if ( k == j &&  m == i )
				continue;
//			if ( matr [ m ][ k / 8 ] & 0x1 << k % 8 )
			if ( matr [ m ][ k >> 3 ] & 0x1 << ( k & 7 ) )
				result ++ ;
		}
	return result;
}
