#include <stdio.h>

#define N 6

int  matrix [ N ][ N ],
     xDelta [ 8 ] = { 2,  1, -1, -2, -2, -1,  1,  2 },
     yDelta [ 8 ] = { 1,  2,  2,  1, -1, -2, -2, -1 };

int horse ( int step , int xPrev, int yPrev )
{
	int i , xNext, yNext , flag = 0;

	for ( i = 0;  i < 8 && flag == 0 ; i ++ ) {
		xNext = xPrev + xDelta [ i ];
		yNext = yPrev + yDelta [ i ];
		if ( xNext >= 0  &&  xNext < N  &&  yNext >= 0   && yNext < N
			&&  matrix [ xNext ][ yNext ] == 0 )  {
			flag = 1;
			matrix [ xNext ][ yNext ] = step ;
			if ( step < N * N )
				flag = horse ( step + 1, xNext , yNext );
			if ( flag == 0 )
				matrix [ xNext ][ yNext ] = 0;
		}
	}
	return  flag;
}

void main ()
{
	int i, j;

	matrix [ 0 ][ 0 ] = 1;
	horse ( 2, 0, 0 );

	for ( i = 0; i < N ; i ++ ) {
		for ( j = 0; j < N; j ++ )
			printf ( "%2d  " , matrix [ i ][ j ]);
		printf ( "\n" );
	}
}



