// TreeView.cpp : implementation of the CMyTreeView class
//

#include "stdafx.h"
#include "Tree.h"

#include "TreeDoc.h"
#include "TreeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView

IMPLEMENT_DYNCREATE(CMyTreeView, CView)

BEGIN_MESSAGE_MAP(CMyTreeView, CView)
	//{{AFX_MSG_MAP(CMyTreeView)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView construction/destruction

CMyTreeView::CMyTreeView()
{
	// TODO: add construction code here
}

CMyTreeView::~CMyTreeView()
{
}

BOOL CMyTreeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView drawing

void CMyTreeView::OnDraw(CDC* pDC)
{
///	CTreeDoc* pDoc = GetDocument();
///	ASSERT_VALID(pDoc);

	int n = 7 , x_root = 320, y_root = 410, length = 70;
	double  alfa = 1.570796;  // PI / 2 ;

	TreePicture (pDC , x_root, y_root, length, alfa, n);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView diagnostics

#ifdef _DEBUG
//DEL void CMyTreeView::AssertValid() const
//DEL {
//DEL 	CView::AssertValid();
//DEL }

//DEL void CMyTreeView::Dump(CDumpContext& dc) const
//DEL {
//DEL 	CView::Dump(dc);
//DEL }

//DEL CTreeDoc* CMyTreeView::GetDocument() // non-debug version is inline
//DEL {
//DEL 	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTreeDoc)));
//DEL 	return (CTreeDoc*)m_pDocument;
//DEL }
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////

void CMyTreeView::TreePicture ( CDC* pDC , int xRoot, int yRoot, int length, double alfa, int n)
{

	if ( n < 1 ) return;

	int xEnd = xRoot + length * cos ( alfa );
	int yEnd = yRoot - length * sin ( alfa );

	int width =  n / 2 + 1 ;  
	int greenColor = n * ( - 15 ) + 240 ;	
	CPen pen ( PS_SOLID , width , RGB ( 0, greenColor , 0 ) );
	pDC -> SelectObject ( & pen ) ;

	pDC -> MoveTo ( xRoot, yRoot );
	pDC -> LineTo ( xEnd, yEnd);

	TreePicture (pDC , xEnd, yEnd, length * ( rand () % 2 + 8 ) / 10.,
		alfa + 3.141592 / ( rand () % 3 + 5 ), n - 1 );
	TreePicture (pDC , xEnd, yEnd, length * ( rand () % 2 + 6 ) / 10.,
		alfa + 3.141592 / ( rand () % 3 + 13) * ( (n % 2) * 2 - 1), n - 1);
	TreePicture (pDC , xEnd, yEnd, length * ( rand () % 2 + 7 ) / 10.,
		alfa - 3.141592 / ( rand () % 4 + 4 ), n - 1);
}

void CMyTreeView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	GetParentFrame () -> PostMessage ( WM_CLOSE );

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
