#include <graphics.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>

void tree (int x_root, int y_root, int length, float alfa, int n)
{
	int x_end = x_root + length * cos ( alfa );
	int y_end = y_root - length * sin ( alfa );

	if ( n < 1 ) return;
	if (n > 5) {
		setlinestyle(SOLID_LINE, 0, THICK_WIDTH);
		setcolor(BROWN);
	} else {
		setlinestyle(SOLID_LINE, 0, NORM_WIDTH);
		setcolor(GREEN);
	}
	line ( x_root, y_root,x_end, y_end);
	tree ( x_end, y_end, length * ( random ( 2 ) + 8 ) / 10.,
		alfa + M_PI / ( random ( 3 ) + 5 ), n - 1 );
	tree ( x_end, y_end, length * ( random ( 2 ) + 6 ) / 10.,
		alfa + M_PI / (random(3) + 13) * ( (n % 2) * 2 - 1), n - 1);
	tree ( x_end, y_end, length * ( random ( 2 ) + 7 ) / 10.,
		alfa - M_PI / ( random ( 4 ) + 4 ), n - 1);
}

void main()
{
	int driver = VGA, mode = VGAHI, x_root = 340, y_root = 450,
	    length = 100, n = 8 ;
	float  alfa = M_PI_2 - .00001;

	initgraph(&driver, &mode, "");
	tree (x_root, y_root, length, alfa, n);
	getch();
	closegraph();
}

