#include <graphics.h>
#include <math.h>
#include <conio.h>

#define FACTOR  0.3

void side ( int xA, int yA, int xB, int yB, int n )
{
	int  xP, yP, xQ, yQ, xR, yR, xS, yS, fDx, fDy;
	if ( n == 0 ) return;
	fDx = ( int )( FACTOR * ( xB - xA )) ;
	fDy = ( int )( FACTOR * ( yB - yA ));
	xP = xA + fDx;
	yP = yA + fDy;
	xS = xB - fDx;
	yS = yB - fDy;
	xQ = xP + ( yS - yP );
	yQ = yP - ( xS - xP );
	xR = xQ + ( xS - xP );
	yR = yQ + ( yS - yP );

	lineto ( xP, yP );
	side ( xP, yP, xQ, yQ, n - 1 );
	side ( xQ, yQ, xR, yR, n - 1 );
	side ( xR, yR, xS, yS, n - 1 );

	lineto ( xB, yB );
}

void main()
{
	int driver = VGA, mode = VGAHI, r = 100, n = 5, xC = 340, yC = 240;
	initgraph(&driver, &mode, "");
	for ( ; n ; n -- , r /= 2 ) {
		moveto ( xC - r, yC - r );
		side ( xC - r , yC - r , xC + r , yC - r , n );
		side ( xC + r , yC - r , xC + r , yC + r , n );
		side ( xC + r , yC + r , xC - r , yC + r , n );
		side ( xC - r , yC + r , xC - r , yC - r , n );
	}
	getch();
	closegraph();
}
