#include <graphics.h>			     // MINCOVSKY's CURVE
#include <conio.h>

#define MODEL 4
float xx [ MODEL ] = { .45, .5, .55 , 1 }, yy [ MODEL ] = { 0, 0.45, 0, 0 };

// #define MODEL 8
// float xx [ MODEL ] = { .25, .25, .5, .5, .5,  .75, .75, 1 },
//       yy [ MODEL ] = { 0,   .25, .25, 0, -.25, -.25, 0, 0 };


void side ( float xA, float yA, float xB, float yB, int n )
{
	int i;
	float  x, y, x1 = xA, y1 = yA, dX = xB - xA, dY = yB - yA;
	if ( n == 0 ) {
		line ( xA, yA, xB, yB );
		return ;
	}

	for ( i = 0; i < MODEL; i++ ) {
		x = x1;   y = y1;
		x1 = xA + dX * xx [ i ] - dY * yy [ i ];
		y1 = yA + dY * xx [ i ] + dX * yy [ i ];
		side ( x, y, x1, y1, n - 1 );
	}
}

void main()
{
	int driver = VGA, mode = VGAHI, n = 5;
	initgraph(&driver, &mode, "");

	side (0, 100 , 600 , 100, n );
	getch();
	closegraph();
}

