#include <stdio.h>

void printMatrix3d_1 ( unsigned sizeI, unsigned sizeJ, unsigned sizeK, int *** pppMatrix )
{
	unsigned i , j , k;
	for ( i = 0 ; i < sizeI ; i ++ ) {
		for ( j = 0 ; j < sizeJ ; j ++ ) {
			for ( k = 0 ; k < sizeK ;  k ++ )
				printf ( "%4d" , * ( * ( * ( pppMatrix + i ) + j ) + k ) );
			( ** pppMatrix ) ++;
			printf ( "\n" );
		}
		 printf ( "\n" );
	}
}

void printMatrix3d_2 ( unsigned sizeI, unsigned sizeJ, unsigned sizeK, int * pMatrix )
{
	unsigned i , j , k;
	for ( i = 0 ; i < sizeI ; i ++ ) {
		for ( j = 0 ; j < sizeJ ; j ++ ) {
			for ( k = 0 ; k < sizeK ;  k ++ )
				printf ( "%4d" , * ( pMatrix + i * sizeJ * sizeK + j * sizeK + k ) );
			printf ( "\n" );
		}
		printf ( "\n" );
	}
}

void main ()
{
	int matr_3d [ 2 ][ 3 ][ 4 ] = { { { 1 , 2 , 3 , 4 },
					  { 5 , 6 , 7 , 8 },
					  { 9 , 10 , 11 , 12 } } ,
					{ { 13 , 14 , 15 , 16 } ,
					  { 17 , 18 , 19 , 20 } ,
					  { 21 , 22 , 23 , 24 } } } , i , j;
	int * matrPoint [ 2 ][ 3 ] ;
	int ** arrPointPoint [ 2 ] ;

	for ( i = 0 ; i < 2 ; i ++ ) {
		for ( j = 0 ; j < 3 ; j ++ )
			matrPoint [ i ][ j ] = matr_3d [ i ][ j ];
		arrPointPoint [ i ] = matrPoint [ i ];
	}

	printMatrix3d_1 ( 2, 3, 4, arrPointPoint );

	printMatrix3d_2 ( 2, 3, 4, ( int * ) matr_3d );
}
