#include <stdio.h>
#include <stdlib.h>
#define  N 6

typedef struct {
	int x , y ;
} Point ;

int  pointInsidePolygon ( Point polygon [ ] , Point  _point )
{
	int counter = 0, i, j;
	float t;
	for ( i = 0; i < N; i++ )  {
		j = ( i + 1 ) % N;
		if ( polygon [ i ].y == polygon [ j ].y ||
		     polygon [ i ].y > _point.y  && polygon [ j ].y > _point.y )
			continue;
		if ( max ( polygon [ i ].y , polygon [ j ].y ) == _point.y )
			counter ++;
		else
			if ( min ( polygon [ i ].y , polygon [ j ].y ) != _point.y ) {
				t = ( (float) _point.y - polygon [ i ].y ) /
					( polygon [ j ].y - polygon [ i ].y);
				if ( t > 0 && t < 1 && polygon [ i ].x + t * ( polygon [ j ].x
				  - polygon [ i ].x ) >= _point.x )
					counter ++;
		}
     }
     return counter % 2 ;
}

void main()
{
	Point  polygon [ N + 1 ] = { { 50 , 50 } , { 200 , 50 } , { 150 , 100 } ,
				     { 200 , 150 } , { 50 , 150 } , { 100 , 100 } ,
				     { 50 , 50 } };
	Point  _point = { 125 , 75 };

	if (  pointInsidePolygon ( polygon, _point ) )
		puts ( "Point inside  polygon");
	else
	       puts ( "Point  outside  polygon");
}