#include <stdio.h>
#define  N  10
typedef struct  {
	int num ;
	unsigned den ;
} Fraction ;

Fraction substruct ( Fraction A , Fraction B )
{
	Fraction temp;
	temp . num = A . num * B . den - B . num * A . den;
	temp . den = A . den * B . den ;
	return temp;
}

int compare ( Fraction A , Fraction B )
{
	Fraction temp = substruct ( A , B );
	if ( temp . num > 0 )
		return 1;
	if ( temp . num < 0 )
		return -1;
	return 0;
}

void main ()
{
	Fraction arrFract [ N ] = { { 1 , 2 } , { - 1 , 3 } , { 5 , 8 } , { - 17 , 3 }  , { - 8 , 5 } ,
				    { 23 , 5 } , { 11 , 2 } , { - 15 , 7 } , { 2 , 9 } , { 2 , 13 } };
	Fraction temp , deltaMin = { 10000 , 1 };
	int i , j , firstIndex , secondIndex ;

	for ( i = 0 ; i < N ; i ++ )
		for ( j = i + 1 ; j < N ; j ++ ) {
			temp = substruct ( arrFract [ i ] , arrFract [ j ] );
			if ( temp . num < 0 )
				temp . num *= - 1;
			if ( compare ( temp , deltaMin ) < 0 ) {
				deltaMin = temp;
				firstIndex = i;
				secondIndex = j;
			}
		}

	printf ( "MIN difference %d / %d between %d / %d  and  %d / %d\n",
			deltaMin . num , deltaMin . den ,
			arrFract [ firstIndex ] . num , arrFract [ firstIndex ] . den ,
			arrFract [ secondIndex ] . num , arrFract [ secondIndex ] . den );
}



