#include <stdio.h>

long equalPartsLength ( FILE * pFirst , long indexFirst , FILE * pSecond , long indexSecond )
{
	long counter = 0;
	fseek ( pFirst , indexFirst , SEEK_SET );
	fseek ( pSecond , indexSecond , SEEK_SET );

	while ( ! feof ( pFirst ) && ! feof ( pSecond ) ) {
		if ( fgetc ( pFirst ) != fgetc ( pSecond ) )
			break ;
		counter ++ ;
	}
	return counter;
}

void main ( int argc , char * argv [ ] )
{
	FILE * pFirst = fopen ( argv [ 1 ] , "r" ),
	     * pSecond = fopen ( argv [ 2 ] , "r" );

	long indexFirst = 0, indexSecond, indexMaxPart = -1, currentLength, maxLength = 0;

	if ( ! pFirst || ! pSecond ) {
		printf ( "fopen () ERROR" );
		return;
	}

	while ( ! feof ( pFirst ) ) {
		indexSecond = 0;
		fseek ( pSecond, indexSecond , SEEK_SET );
		while ( ! feof ( pSecond ) ) {
			currentLength = equalPartsLength ( pFirst, indexFirst,
						pSecond, indexSecond ) ;
			if ( currentLength > maxLength ) {
				maxLength = currentLength ;
				indexMaxPart = indexFirst ;
			}
			fseek ( pSecond, indexSecond , SEEK_SET );
			fgetc ( pSecond ) ;
			indexSecond ++ ;
		}
		fseek ( pFirst , indexFirst , SEEK_SET );
		fgetc ( pFirst ) ;
		indexFirst ++ ;

	}
	if ( indexMaxPart >= 0 ) {
		fseek ( pFirst , indexMaxPart , SEEK_SET );
		while ( maxLength -- )
			putc ( fgetc ( pFirst ) , stdout );
	}
	fcloseall ();
}
