#include <graphics.h>
#include <math.h>
#include <conio.h>

#define COLOR LIGHTRED
#define N 7000

void spiral ( int xC , int yC, int radius , int ratio )
{
	int angle, x1 = radius / ratio, y1 = 0, x2, y2;

	for ( angle = 0 ; angle <= N ; angle+= 20 ) 	{
		radius += 20;
		x2 = radius * cos ( 0.0069813168 * angle ) / ratio ;
		y2 = radius * sin ( 0.0069813168 * angle ) / ratio ;
		line ( x1 + xC, y1 + yC, x2 + xC, y2 + yC );
		x1 = x2;
		y1 = y2;
	}
}

void main()
{       int driver = VGA , mode = VGAHI;
	int xC = 320, yC = 240, rad1 = 50, rad2 = 500, ratio = 100 ;
	initgraph ( &driver, &mode, "" );

	spiral ( xC - 200, yC, rad1, ratio );

	spiral ( xC , yC, rad1, ratio );
	spiral ( xC , yC, rad2, ratio );
	line ( xC + rad1 / ratio, yC, xC + rad2 / ratio, yC );
	line ( xC + ( rad1 + N ) * cos ( 0.0069813168 * N ) / ratio ,
	       yC + ( rad1 + N ) * sin ( 0.0069813168 * N ) / ratio ,
	       xC + ( rad2 + N ) * cos ( 0.0069813168 * N ) / ratio ,
	       yC + ( rad2 + N ) * sin ( 0.0069813168 * N ) / ratio );

	setfillstyle  ( SOLID_FILL , RED );
	floodfill ( xC, yC + 5, WHITE );
	getch ();
}
