// SplinSServView.h : interface of the CSplinSServView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPLINSSERVVIEW_H__6D3C21EC_F66A_11D3_96A5_0020182E9467__INCLUDED_)
#define AFX_SPLINSSERVVIEW_H__6D3C21EC_F66A_11D3_96A5_0020182E9467__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
	

const int NODES = 6 ;
const int N = 15 ;                  // INTERNAL POINTS BETWEEN NODES
const int arrSize = 6 * NODES + 4 ; ///+ 3

class CSplinSServView : public CView
{
protected: // create from serialization only
	CSplinSServView();
	DECLARE_DYNCREATE(CSplinSServView)

	unsigned char lastRed, signRed, lastGreen, signGreen , lastBlue , signBlue ;
	int counterColor ;

	POINT arrPoints [ arrSize ];
	struct {
		char xSign, ySign;
	} arrSign [ arrSize ] ;

// Attributes
public:
	CSplinSServDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSplinSServView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSplinSServView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSplinSServView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SplinSServView.cpp
inline CSplinSServDoc* CSplinSServView::GetDocument()
   { return (CSplinSServDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPLINSSERVVIEW_H__6D3C21EC_F66A_11D3_96A5_0020182E9467__INCLUDED_)

