#include <malloc.h>
#include <iostream.h>                      

const unsigned N = 1000 ;

class Fraction {
	int numerator;
	unsigned denominator;
	static int lastIndex;
	static int arrLength [ 100 ], arrBegin [ 100 ];
public:	
	Fraction ( int num = 0, unsigned denom = 1 )  {
		numerator = num  ;
		denominator = denom ;
	}
	~Fraction () {}
	void * operator new [] ( unsigned ) ;
	void  operator delete [] ( void * );
	friend ostream & operator << ( ostream & , const Fraction & );
};
ostream & operator << ( ostream & s , const Fraction & temp )
{
	s << temp . numerator << " / " << temp. denominator ;
	return s ;
}

Fraction arrMemory [ N ] ;

void*   Fraction :: operator new[] ( unsigned s ) 
{ 
	unsigned size = ( s - sizeof ( int ) ) / sizeof ( Fraction ); 
	for ( int i = 0; i <= lastIndex ; i ++ ) 
		if ( - arrLength [ i ] >= ( signed ) size ) { 
			arrLength [ i ] = size ;
			cout << "\n\nAllocate: from element  " << arrBegin [ i ]  << "  to element  " << arrBegin [ i ] + size - 1; 
			return & arrMemory [ arrBegin [ i ] ];
		}
	if ( arrLength [ lastIndex ] + size > N ) 
		return NULL ;

	lastIndex ++ ;
	arrLength [ lastIndex ] = size;
	if ( lastIndex == 0 ) arrBegin [ 0 ] = 0;
		else arrBegin [ lastIndex ] = arrBegin [ lastIndex - 1 ] + size - 1;
	cout << "\n\nAllocate: from element  " << arrBegin [ lastIndex ]  << "  to element  " << arrBegin [ lastIndex ] + size - 1 ; 

	return arrMemory + arrBegin [ lastIndex ] ;
}

void  Fraction :: operator delete[] ( void * p )
{
	for ( int i = 0; i <= lastIndex ; i ++ ) 
		if ( arrBegin [ i ] == ( Fraction * ) p  - arrMemory )
			break ;
	cout << "\n\nFree: from element  " << arrBegin [ i ]  << "  to element  " << arrBegin [ i ] + arrLength [ i ] - 1; 
	if ( i == lastIndex ) 
		lastIndex --;
	else 
		arrLength [ i ] *= -1 ;
}

int Fraction :: arrLength [ 100 ];
int Fraction :: arrBegin [ 100 ];
int Fraction :: lastIndex = -1;

void main( void)
{
    Fraction * pA = new Fraction [ 2 ];
	cout << "\nArray pA     " ;

	for( int i = 0; i < 2; i++ )
		 pA [ i ] = Fraction( i, i + 1);
	for( i = 0; i < 2; i++ )
		cout << pA [ i ] << "  " ;

	Fraction * pB = new Fraction [ 3 ];
	for( i = 0; i < 3; i++ )
		 pB [ i ]= Fraction ( 2 * i, 2 * i + 2 );
	cout << "\nArray pB     " ;
	for( i = 0; i < 3; i++ )
		cout << pB [ i ] << "  " ;

	Fraction * pC = new Fraction [ 4 ];
	
	delete [ ] pB ;

	Fraction * pD = new Fraction [ 2 ];
	cout << "\nArray pD     " ;
	for( i = 0; i < 2; i++ )
		 pD [ i ]= Fraction( 3 * i, 3 * i + 3 );
	for( i = 0; i < 2; i++ )
		cout << pD [ i ] << "  " ;

	delete [] pA;
	delete [] pC;
	delete [] pD;
}

