#include <iostream.h>

class Fraction {
	int num;
	unsigned denom;
public:
	Fraction ( int n = 0, unsigned d = 1 ) { num = n ; denom = d ; }
	bool operator> ( const Fraction & A ) const { 
		return num * ( signed ) A.denom > ( signed ) denom * A.num ;}
	bool operator< ( const Fraction & A )  const { 
		return num * ( signed ) A.denom < ( signed ) denom * A.num ;}
	friend ostream & operator << ( ostream & , const Fraction & );
};

ostream & operator << ( ostream & s , const Fraction & temp )
{
	s << temp . num << " / " << temp. denom;
	return s ;
}

template <class T>
void  MaxMinElement (  const T arr [], int first , int last, T & MaxElem , T & MinElem )
{
	T localMax_1, localMax_2, localMin_1, localMin_2;
	if ( last == first ) {
		MaxElem = MinElem = arr [ first ];
		return ;
	}
	MaxMinElement ( arr , first, (first + last)/ 2, localMax_1 , localMin_1 );
	MaxMinElement ( arr , (first + last) / 2 + 1, last, localMax_2 , localMin_2 );
	MaxElem = localMax_1 > localMax_2 ? localMax_1 : localMax_2 ;
	MinElem = localMin_1 < localMin_2 ? localMin_1 : localMin_2 ;
}

void main()
{
	int arrInt [ 10 ] = { 34, 12, 76, -45, 23, 56, 100, 68 , -98 , 7}, MaxInt, MinInt;
	MaxMinElement ( arrInt , 0, 9, MaxInt , MinInt );
	cout << "MAX Int = " << MaxInt << "   MIN Int = " << MinInt << endl;

	Fraction arrFraction [ 5 ] = { Fraction ( -7, 8 ), Fraction ( -3 ),
		Fraction ( 5, 2 ), Fraction ( 1, 2 ), Fraction ( 2 ) },
		MaxFraction, MinFraction ;
	MaxMinElement ( arrFraction , 0, 5, MaxFraction , MinFraction );
	cout << "MAX Fraction = " << MaxFraction << "   MIN Fraction = " << MinFraction;
}