#include <iostream.h>

template < class X >
X Average ( const X & a , const X & b )
{
	return ( a + b ) / 2 ;
}

template < class Y >
class Complex {
	Y real , image;
public: Complex ( ) { }
	Complex ( Y  r, Y i ) : real ( r ), image ( i ) { }
	Complex operator + ( const Complex & second) const  {
		return Complex < Y > ( real + second.real, image + second.image );
	}
	Complex operator / ( int i ) const {
		return Complex < Y > ( real / i , image / i );
	}
	friend ostream & operator<< ( ostream & , const Complex & );
};
template < class Y >
ostream & operator<< ( ostream & s, const Complex < Y > & temp )
{
	s << temp.real << " + i * " << temp.image ;
	return s ;
}

void main ( void )
{
	short A = 5, B = 8 ;
	cout << Average ( A, B ) << endl ;

	Complex < long > C ( 1, 2 ), D ( 3, 4 );
	cout << Average ( C , D ) << endl ;

	Complex < double > E ( 1.1111, 2.2222 ), F ( 3.3333 , 4.4444 );
	cout << Average ( E , F );
}
