#include <iostream.h>	   // throw - try - catch: string  "multiplication"
#include <string.h>	   // "abcd" * 3 = "abcdabcdabcd"

char * stringMultiply ( const char * str, int  n )
{
	if ( str [ 0 ] == '\0' || n <= 0 )
		throw ( n );
	char * result = new char [ strlen ( str ) * n + 1 ];
	if ( result == NULL )
		throw ( result );
	result [ 0 ] = 0;
	for ( int i= 0 ; i < n; i ++ )
		strcat ( result, str );
	return result ;
}

void main ( )
{
	char string [ ] = "abcd";                   
	int number;
	cin >> number;

	try  	{
		char * result = stringMultiply ( string , number );
		cout << result << endl;
		delete [] result;
	}
	catch ( int n ) {
		if ( n > 0 )
			cout << "Beginner String is empty" << endl;
		else 	if ( n == 0 )
				  cout << "Number is Zero" << endl;
				else
				  cout << "Number is negative" << endl ;
	}
	catch ( char * ) {
		cout << "Number is too large ( Memory allocation error )" << endl ;
	}
}

