#include <iostream.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>

#define MAX_STRING_LENGTH 100

void printMessage ( int i, const char * mess )
{
		cout << "Error in string  " << i + 1 << " : " << mess << endl; 
}

char * myStrCat ( int size , ... )
{
	if ( size <= 0 )
		throw ( size );
	va_list myArguments;
	va_start ( myArguments , size );
	int commonLength = 0 , currLength ;
	char * temp;
	for ( int i = 0; i < size ; i ++ ) {
		temp = va_arg ( myArguments, char * ) ;
		currLength = strlen ( temp );
		if ( currLength == 0 )
			throw ( printMessage ( i ,"String is empty" ) );
		if ( currLength > MAX_STRING_LENGTH )
			throw ( printMessage ( i ,"String is too long" ) );
		while ( * temp ) {
			if ( ! isprint ( * temp ) && ! isspace (* temp ) ) 
				throw ( printMessage ( i, "Symbol isn't correct" ));
			temp ++ ;
		}
		commonLength += currLength ;
	}
	char * pResult = new char [ commonLength + 1 ];
	if ( pResult == NULL )
		throw ( pResult );
	* pResult = 0;
	va_start ( myArguments , size );
	for ( i = 0; i < size ; i ++ ) {
		temp = va_arg ( myArguments, char * ) ;
		strcat ( pResult , temp );
	}
	va_end ( myArguments );
	return pResult;
}

void main ( void )
{
	try  {                           //// OUTPUT abcdefghij
//		char * result = myStrCat ( 4 , "a" , "bc" , "def" , "ghij");

		                           //// OUTPUT abc
//		char * result = myStrCat ( 2 , "a" , "bc" , "def" , "ghij");

/*		int arr1 [ 1 ] = { 'a' }, arr2 [ 2 ] = { 'b', 'c'  };
		char * result = myStrCat ( 2 , arr1 , arr2 );  
*/									//// OUTPUT ab

/*		float arr1 [ 1 ] = { 'a' }, arr2 [ 2 ] = { 'b', 'c'  };
		char * result = myStrCat ( 2 , arr1 , arr2 );  
*/									//// Error in string 1 : String is empty

		char * result = myStrCat ( -4 , "a" , "bc" , "def" , "ghij");
									/// Number isn't positive

//		char * result = myStrCat ( 400 , "a" , "bc" , "def" , "ghij");
									//// Error in string 5 : Symbol isn't correct

/*		char * result = myStrCat ( 4 , "a" , "b                         \
                                                                        \
                                                                        \
                  c" , "def" , "ghij");
*/									//// Error in string 2 : String is too long

//		char * result = myStrCat ( 4 , "" , "" , "" , "");
									//// Error in string 1 : Symbol isn't correct
		cout << result << endl;
		delete [ ] result;
	}
	catch ( int ) {
		cout << "Error : Number isn't positive" << endl;
	}
	catch ( char * ) {
		cout << "Memory allocation error" << endl ;
	}
	catch ( void ( * ) ( int , char * ) ) {
	}
}
