#include <iostream.h>
#include <string.h>
class CircleList {
	char info ;
	CircleList * next;
public: CircleList ( char nInfo , CircleList * nNext) { info = nInfo ; next = nNext; }
	CircleList * buildCircleList ( char * );
	void deleteCircleList () ;

	void print ( );
	CircleList * split ( CircleList * & );
};

CircleList * CircleList :: buildCircleList ( char * data )
{
	CircleList * start ;
	start =  new CircleList ( * data ++ , this );
	for ( CircleList * current = start; * data ;  current = current -> next )
		current -> next = new CircleList ( * data ++ , current );
	current -> next = start ;
	return start ;
}

void CircleList :: deleteCircleList ( )
{
	CircleList * temp = this , * current = this -> next ;
	while ( current != this ) {
		delete temp;
		temp = current;
		current = current -> next ;
	}
}

void CircleList :: print ( )
{       cout << this -> info << "  ";
	for ( CircleList * current = this -> next ; current != this  ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

CircleList * CircleList :: split ( CircleList * & begin2 )
{

	CircleList * current = this -> next, * largeFirst = this , * largeLast , * smallFirst = this , * smallLast;

	while ( largeFirst -> info >= 'a' && largeFirst -> info <= 'z' )
		largeFirst = largeFirst -> next;
	while ( smallFirst -> info >= 'A' && smallFirst -> info <= 'Z' )
		smallFirst = smallFirst -> next;
	largeLast = largeFirst ;
	smallLast = smallFirst ;

	while ( current !=  this ) {
		if ( current == largeFirst || current == smallFirst )
			current = current -> next;
		if ( current -> info >= 'a' && current -> info <= 'z' ) {
			smallLast -> next = current;
			smallLast = current;
		}
		else {
			largeLast -> next = current;
			largeLast = current;
		}
		current = current -> next;
	}

	largeLast -> next = largeFirst ;
	smallLast -> next = smallFirst;
	begin2 = smallFirst ;
	return largeFirst;
}

void main ()
{
	CircleList * begin1 = NULL, * begin2 = NULL ;
	char string [ ] = "ABcDefGhiJ";

	begin1 = begin1 -> buildCircleList ( string );
	begin1 -> print ( );

	begin1 = begin1 -> split ( begin2 );

	begin1 -> print ( );
	begin2 -> print ( );

	begin1 -> deleteCircleList ( );
	begin2 -> deleteCircleList ( );
}
