#include <iostream.h>
#include <string.h>
class List {
	char info ;
	List * next;
public: List ( char nInfo , List * nNext) { info = nInfo ; next = nNext; }
	List * additionElement ( char newInfo ) { return new List ( newInfo, this ); }
	List * deleteElement () {
		if ( this ) {
			List * temp = next;
			delete this;
			return temp;
		}
		return NULL;
	}
	void print ( );
	bool isPalindrome ( );
	bool isPalindromeRecursive ( );
};

void List :: print ( )
{	for ( List * current = this ; current ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

bool List :: isPalindrome ( )
{
	List * begin = this , * end = this , * temp ;
	while ( end -> next )
		end = end -> next ;
	while ( begin != end && end -> next != begin ) {
		if ( begin -> info != end -> info )
			return false ;
		begin = begin -> next ;
		temp = end ;
		for ( end = begin ; end -> next != temp; end = end -> next )
			;
	}
	return true;
}

bool List :: isPalindromeRecursive ( )
{
	static List * current = this ;

	if ( this -> next && this -> next -> isPalindromeRecursive ( ) == false )
			return false;

	if ( this -> info != current -> info )
		return false ;

	current = current -> next ;
	return true ;
}

void main ()
{
	List * begin = NULL ;
	char string [ ] = "abcdedcba", * pS = string + strlen ( string ) - 1;

	while ( pS >= string )
		begin = begin -> additionElement ( * pS -- );

	begin -> print ( );

	if ( begin -> isPalindrome ( ) )
		cout << "Is palindrome\n";
	else
		cout << "Isn't palindrome\n";

	if ( begin -> isPalindromeRecursive ( ) )
		cout << "Is palindrome\n";
	else
		cout << "Isn't palindrome\n";


	while ( begin )
		begin = begin -> deleteElement ();
}