// Two Lists :
//  A -> B -> C -> D -> E
//  a -> b -> c -> d -> e -> f -> g
// After Merge
//  A -> a -> B -> b -> C -> c -> D -> d -> E -> e -> f -> g
#include <iostream.h>
#include <string.h>
class List {
	char info ;
	List * next;
public: List ( char nInfo , List * nNext) { info = nInfo ; next = nNext; }
	List * additionElement ( char newInfo ) { return new List ( newInfo, this ); }
	List * deleteElement () {
		if ( this ) {
			List * temp = next;
			delete this;
			return temp;
		}
		return NULL;
	}
	void print ( );
	List * merge ( List * ) ;
};
void List :: print ( )
{	for ( List * current = this ; current ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

List * List :: merge ( List * current2 )
{
	List * current1 = this, * last = this ;

	while ( current1 -> next && current2 -> next ) {
		current1 = current1 -> next;
		last -> next = current2;
		last = current2;

		current2 = current2 -> next;
		last -> next = current1;
		last = current1;
	}
	if ( current1 -> next == NULL )
		current1 -> next = current2;
	else {
		current1 = current1 -> next;
		last -> next = current2;
		current2 -> next = current1;
	}
	return this;
}

void main ()
{
	List * begin1 = NULL, * begin2 = NULL;
	char string1 [ ] ="ABCDE", * pS1 = string1 + strlen ( string1 ) - 1;
	char string2 [ ] = "abcdefg", * pS2 = string2 + strlen ( string2 ) - 1;

	while ( pS1 >= string1 )
		begin1 = begin1 -> additionElement ( * pS1 -- );
	while ( pS2 >= string2 )
		begin2 = begin2 -> additionElement ( * pS2 -- );

	cout << "Before merge\n" ;
	begin1 -> print ( );
	begin2 -> print ( );

	begin1 = begin1 -> merge ( begin2 );
	begin2 = NULL ;
	cout << "After merge\n" ;
	begin1 -> print ( );

	while ( begin1 )
		begin1 = begin1 -> deleteElement ();
}
