//  e -> f -> b -> c -> h -> a -> d -> g
// After Merge Sort
//  a -> b -> c -> d -> e -> f -> g -> h
#include <iostream.h>
#include <string.h>
class List {
	char info ;
	List * next;
public: List ( char nInfo , List * nNext) { info = nInfo ; next = nNext; }
	List * additionElement ( int newInfo ) { return new List ( newInfo, this ); }
	List * deleteElement () {
		if ( this ) {
			List * temp = next;
			delete this;
			return temp;
		}
		return NULL;
	}
	void print ( );
	List * merge ( List * ) ;
	List * mergeSort ();
};
void List :: print ( )
{	for ( List * current = this ; current ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

List * List :: merge ( List * current2 )
{
	List * current1 = this , * last, * first , * temp ;
	if ( info < current2 -> info ) {
		if ( next == NULL ) {            // uniq element in first list
			next = current2;
			return this;
		}
		first = last = this;
		current1 = current1 -> next;
	}
	else  {
			if ( current2 -> next == NULL ) { // uniq element in second list
				current2 -> next = this;
				return current2;
			}
			first = last = current2;
			current2 = current2 -> next;
	}

	while ( current1 && current2 ) {
		if ( current1 -> info < current2 -> info ) {
			last -> next = current1;
			current1 = current1 -> next;
		}
		else {
				last -> next = current2;
				current2 = current2 -> next;
		}
		last = last -> next;
	}
	if ( current1 == NULL )
		last -> next = current2;
	else
		last -> next = current1;
	return first;
}

List * List :: mergeSort ()
{
	List * current , * temp ;
	int counter = 0, i;
	for ( current = this; current; current = current -> next )
		counter ++ ;
	if ( counter == 1 )
		return this;

	for ( i = 0, current = this; i < counter / 2 - 1 ; i ++ , current = current -> next )
		;
	temp = current;
	current = current -> next;
	temp -> next = 0;

	temp = this -> mergeSort ();
	current = current -> mergeSort ();

	temp = temp -> merge ( current );

	return temp;
}

void main ()
{
	List * begin = NULL;
	char string [ ] ="eicfbchadg", * pS = string + strlen ( string ) - 1;

	while ( pS >= string )
		begin = begin -> additionElement ( * pS -- );

	cout << "Before Sort\n" ;
	begin -> print ( );

	begin = begin -> mergeSort ( );

	cout << "After Sort\n" ;
	begin -> print ( );

	while ( begin )
		begin = begin -> deleteElement ();
}
