#include <iostream.h>

template < class T >
class Stack {
	T info;
	Stack * next;
public: Stack ( T newInfo , Stack * newNext ) {
			info = newInfo;  next = newNext;
		}
	Stack * PUSH ( T );
	Stack * POP ();
	char infoOut () { return info ; }

	Stack * print ( ) ;
	Stack * reverse ( );
	Stack * partition ( Stack * & );
};

template < class T >
Stack < T > * Stack < T > :: PUSH ( T newInfo )
{
	Stack < T > * pTemp = new Stack < T > ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

template < class T >
Stack < T > * Stack < T > :: POP ( )
{
	Stack < T > * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}
template < class T >
Stack < T > * Stack < T > :: print ( )
{
	Stack < T > * pTemp = NULL, * pTop = this ;
	while ( pTop ) {
		cout <<  pTop -> info << "  ";
		pTemp = pTemp -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );
	}
	while ( pTemp ) {
		pTop = pTop -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP ( );
	}
	return pTop ;
}

template < class T >
Stack < T > * Stack < T > :: reverse ( )
{
	Stack < T > * temp = this, * pReserve = NULL;

	while ( temp ) {
		pReserve = pReserve -> PUSH ( temp -> info );
		temp = temp -> POP () ;
	}
	return pReserve ;
}

template < class T >
Stack < T > * Stack < T > :: partition ( Stack < T > * & top2 )
{
	Stack < T > * top1 = this , * temp = NULL;
	int i = 1, indexCurr = 1, indexMax, lengthCurr = 1, lengthMax = 1 ;

	temp = temp -> PUSH ( top1 -> info );
	top1 = top1 -> POP ( );

	while ( top1 ) {
		if ( top1 -> info > temp -> info )
			lengthCurr ++;
		else {
			if ( lengthCurr > lengthMax ) {
			      indexMax = indexCurr;
			      lengthMax = lengthCurr;
			}
			lengthCurr = 1  ;
			indexCurr = i;
		}
		i ++ ;
		temp = temp -> PUSH ( top1 -> info );
		top1 = top1 -> POP ( );
	}
	if ( lengthCurr > lengthMax ) {
	      indexMax = indexCurr;
	      lengthMax = lengthCurr;
	}

	temp = temp -> reverse ();
	for ( i = 0; i < indexMax; i ++ ) {
		top1 = top1 -> PUSH ( temp -> info );
		temp = temp -> POP ( );
	}
	for ( i = 0; i < lengthMax; i ++ ) {
		top2 = top2 -> PUSH ( temp -> info );
		temp = temp -> POP ( );
	}
	while ( temp ) {
		top1 = top1 -> PUSH ( temp -> info );
		temp = temp -> POP ( );
	}
	top2 = top2 -> reverse ();
	return   top1 -> reverse ();
}

void main ()
{
	Stack  < int > * pTop1 = NULL, * pTop2 = NULL ;
	int Arr [ 10 ] = { 1, 3, -2, 2, 1, 4, 5, -8, 9, 5 }, * pA = & Arr [ 9 ] ;

	while ( pA >= Arr )
		pTop1 = pTop1 -> PUSH ( * pA -- );

	cout << "\nBefore partition \n" ;
	pTop1 = pTop1 -> print ( );

	pTop1 = pTop1 -> partition ( pTop2 );

	cout << "\nAfter partition \nFirst Stack :\n" ;
	pTop1 = pTop1 -> print ( );
	cout << "\nSecond Stack :\n" ;
	pTop2 = pTop2 -> print ( );

	while ( pTop1 )
		pTop1 = pTop1 -> POP();
	while ( pTop2 )
		pTop2 = pTop2 -> POP();
}
