// STACK:  Delete identical elements
// Source:  a -> b -> a -> c -> c -> b -> a -> d -> a -> a
// Target:  a -> b -> c -> d

#include <iostream.h>
#include <string.h>


class Stack {
	char info;
	Stack * next;
public: Stack ( char newInfo , Stack * newNext ) {	
			info = newInfo;  next = newNext;
		}
	Stack * PUSH ( char );
	Stack * POP ();
	char infoOut () { return info ; }

	Stack * print ( ) ;
	Stack * deleteIdentical ( );
};

Stack * Stack :: PUSH ( char newInfo )
{
	Stack * pTemp = new Stack ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

Stack * Stack :: POP ( )
{
	Stack * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}

Stack * Stack :: print ( )
{
	Stack * pTemp = NULL, * pTop = this ;
	while ( pTop ) {
		cout <<  pTop -> info << "  ";
		pTemp = pTemp -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );
	}
	while ( pTemp ) {
		pTop = pTop -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP ( );
	}
	return pTop ;
}

Stack * Stack :: deleteIdentical ( )
{
	Stack * pTop = this , * pResult = NULL , * pTemp = 0;

	while ( pTop ) {

		pResult = pResult -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );

		while ( pTop ) {
			if ( pTop -> info != pResult -> info )
				pTemp = pTemp -> PUSH ( pTop -> info );
			pTop = pTop -> POP ( );
                }

		while ( pTemp ) {
			pTop = pTop -> PUSH ( pTemp -> info );
			pTemp = pTemp -> POP ( );
		}
	}
	while ( pResult ) {
		pTop = pTop -> PUSH ( pResult -> info );
		pResult = pResult -> POP ( );
	}
	return pTop ;
}


void main ()
{
	Stack * pTop = NULL ;
	char data [ ] = "abaccbadaa" ;

	char * pStr = data + strlen ( data ) - 1;
	while ( pStr >= data )
		pTop = pTop -> PUSH ( * pStr -- );

	cout << "\nStack :   " ;
	pTop = pTop -> print ( );

	cout << "\nAfter Delete Identical :   " ;
	pTop = pTop -> deleteIdentical ();
	pTop = pTop -> print ( );

	while ( pTop )
		pTop = pTop -> POP();
}
