// STACK:  Delete identical elements
// Source:  a -> b -> a -> c -> c -> b -> a -> d -> a -> a
// Target:  a -> b -> c -> d

#include <iostream.h>
#include <string.h>

template < class T >
class Stack {
	T info;
	Stack * next;
public: Stack ( T newInfo , Stack * newNext ) {
			info = newInfo;  next = newNext;
		}
	Stack * PUSH ( T );
	Stack * POP ();
	char infoOut () { return info ; }

	Stack * print ( ) ;
	Stack * deleteIdentical ( );
};

template < class T >
Stack < T > * Stack < T > :: PUSH ( T newInfo )
{
	Stack < T > * pTemp = new Stack < T > ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

template < class T >
Stack < T > * Stack < T > :: POP ( )
{
	Stack < T > * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}
template < class T >
Stack < T > * Stack < T > :: print ( )
{
	Stack < T > * pTemp = NULL, * pTop = this ;
	while ( pTop ) {
		cout <<  pTop -> info << "  ";
		pTemp = pTemp -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );
	}
	while ( pTemp ) {
		pTop = pTop -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP ( );
	}
	return pTop ;
}

template < class T >
Stack < T > * Stack < T > :: deleteIdentical ( )
{
	Stack < T > * pTop = this , * pResult = NULL , * pTemp = 0;

	while ( pTop ) {

		pResult = pResult -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );

		while ( pTop ) {
			if ( pTop -> info != pResult -> info )
				pTemp = pTemp -> PUSH ( pTop -> info );
			pTop = pTop -> POP ( );
                }

		while ( pTemp ) {
			pTop = pTop -> PUSH ( pTemp -> info );
			pTemp = pTemp -> POP ( );
		}
	}
	while ( pResult ) {
		pTop = pTop -> PUSH ( pResult -> info );
		pResult = pResult -> POP ( );
	}
	return pTop ;
}


void main ()
{
	Stack < char > * pTopChar = NULL ;
	char dataChar [ ] = "abaccbadaa" ;

	char * pChar = dataChar + strlen ( dataChar ) - 1;
	while ( pChar >= dataChar )
		pTopChar = pTopChar -> PUSH ( * pChar -- );

	cout << "\nStack_Char :   " ;
	pTopChar = pTopChar -> print ( );

	cout << "\nAfter Delete Identical :   " ;
	pTopChar = pTopChar -> deleteIdentical ();
	pTopChar = pTopChar -> print ( );


	Stack < int > * pTopInt = NULL ;
	int dataInt [ 10 ] = { 5, -1, 2 , 5 , -1 , 7 , 2 , 8, 8 , -1 }  ;

	int * pInt = dataInt + 9;
	while ( pInt >= dataInt )
		pTopInt = pTopInt -> PUSH ( * pInt -- );

	cout << "\nStack_Int :   " ;
	pTopInt = pTopInt -> print ( );

	cout << "\nAfter Delete Identical :   " ;
	pTopInt = pTopInt -> deleteIdentical ();
	pTopInt = pTopInt -> print ( );

	while ( pTopChar )
		pTopChar = pTopChar -> POP();

	while ( pTopInt )
		pTopInt = pTopInt -> POP();
}
