#include <iostream.h>

class Stack {
	int info;
	Stack * next;
public: Stack ( int , Stack * );
	Stack * PUSH ( int );
	Stack * POP ();
	int firstInfo () { return this -> info; }

	Stack * print ();

	Stack * increaseSequence ();
};

Stack :: Stack ( int newInfo , Stack * newNext )
{	info = newInfo;
	next = newNext;
}

Stack * Stack :: PUSH ( int newInfo )
{
	Stack * pTemp = new Stack ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

Stack * Stack :: POP ( )
{
	Stack * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}

Stack * Stack :: print ( )
{
	Stack * pTemp = NULL, * pTop = this ;
	while ( pTop ) {
		cout <<  pTop -> info << "  ";
		pTemp = pTemp -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );
	}
	while ( pTemp ) {
		pTop = pTop -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP ( );
	}
	return pTop ;
}

Stack * Stack :: increaseSequence ()
{
	Stack * top = this , * temp = NULL;
	int delta ;

	temp = temp -> PUSH ( top -> info );
	top = top -> POP ( );

	delta = top -> info - temp -> info;

	temp = temp -> PUSH ( top -> info );
	top = top -> POP ( );

	while ( top ) {
		if ( top -> info - temp -> info > delta ) {
		       delta = top -> info - temp -> info;
		       temp = temp -> PUSH ( top -> info );
		}
		top = top -> POP ( );
	}

	while ( temp ) {
		top = top -> PUSH ( temp -> info );
		temp = temp -> POP ( );
	}
	return top ;
}

void main ()
{
	Stack * pTop = NULL ;
	int Arr [ 11 ] = { -2, -5, 0, 1, -3, 7, 19, 17, 35, 38 }, * pA = & Arr [ 10 ] ;

	while ( pA >= Arr )
		pTop = pTop -> PUSH ( * pA -- );

	cout << "\nBefore delete \n" ;
	pTop = pTop -> print ( );

	pTop = pTop -> increaseSequence ();

	cout << "\nAfter delete \n" ;
	pTop = pTop -> print ( );

	while ( pTop )
		pTop = pTop -> POP();
}