#include <iostream.h>

#define STOP 11111
#define EMPTY -9999
template < class T >
class	Tree  {
	T info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( T );
	void deleteTree ();

	Tree * copyTree ( ) ;

	int Depth ( ) ;
	void fillMatrixToPrint ( int , int [ ] , T [][ 32 ] );
	void treePrint () ;
};
template < class T >
Tree < T > * Tree < T > :: additionElement ( T newInfo )
{       Tree < T > * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree < T >  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info  && current -> right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN Tree < T >\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree < T >  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree < T >  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}
template < class T >
void Tree < T > :: deleteTree  ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

template < class T >
Tree < T > * Tree < T > :: copyTree  ( )
{
	Tree < T > * current = new Tree < T > ( this -> info );

	if ( this -> left )
		current -> left = this -> left -> copyTree ( );
	else
		current -> left = NULL;
	if ( this -> right )
		current -> right = this -> right -> copyTree ( );
	else
		current -> right = NULL;
	return current;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

template < class T >
int Tree < T > :: Depth ( )
{
	if ( this == NULL )
		return  - 1 ;
	int depthLeft = this -> left -> Depth ();
	int depthRight = this -> right -> Depth ();
	return  depthLeft > depthRight ? depthLeft + 1 : depthRight + 1;
}
template < class T >
void Tree < T > :: fillMatrixToPrint ( int depth, int arrPositions [ ], T matr [][ 32 ] )
{
	static level = - 1 ;
	static Tree < T > * treeNull = NULL;

	level ++ ;
	if ( depth > 0 )
		if ( this && this -> left )
			this -> left -> fillMatrixToPrint ( depth - 1 ,arrPositions, matr) ;
		else
			treeNull -> fillMatrixToPrint ( depth - 1 ,arrPositions, matr) ;

	if ( this ) 
		matr [ level ][ arrPositions [ level ] ] = this -> info;

	if ( depth > 0 )
		if ( this && this -> right )
			this -> right -> fillMatrixToPrint ( depth - 1 ,arrPositions, matr) ;
		else
			treeNull -> fillMatrixToPrint ( depth - 1 ,arrPositions, matr) ;

	arrPositions [ level ] ++ ;
	level -- ;
}
template < class T >
void Tree < T > :: treePrint ( )
{
	int depth = this -> Depth ();
	if ( depth > 5 ) {
		cout << "\nTree < T > is too large\n";
		return;
	}

	T matr [ 6 ][ 32], arrPositions [ 6 ] = { 0 }, length = 32, i, j;
	char str [ 33 ] = "                                ";

	for ( i = 0; i <= depth; i ++ )
		for ( j = 0; j < 32 ; j ++ )
			matr [ i ][ j ] = EMPTY;

	this -> fillMatrixToPrint ( depth, arrPositions, matr ) ;
	for ( i = 0; i <= depth ; i ++ ,length /= 2 ) {
		str [ length ] = 0;
		for ( j = 0; j < arrPositions [ i ] ; j ++ ) {
			if ( j == 0 )
				cout << endl << str ;
			else
				cout << str << str ;

			if ( matr [ i ][ j ] != EMPTY ) {
				cout.width ( 2 );
				if ( j )
					cout << '\b';
				cout << '\b' << matr [ i ][ j ] ;
			}
		}
	}
}

void main  ()
{

	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 43, 67,
				16, 42, 44, 68 , STOP };

	Tree < int > * begin1 = NULL, * begin2 = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin1 = begin1 -> additionElement ( arrInfo [ i ++ ] );
	cout << "First Tree < T > :\n";
	begin1 -> treePrint ();

	begin2 = begin1 -> copyTree ();
	cout << "\nSecond Tree  :\n";
	begin2 -> treePrint ();
	cout << "\n\n";
	begin1 -> deleteTree ();
	begin2 -> deleteTree ();
}