#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL ) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void deleteTree ();

	bool treesAreEqual ( Tree * );
};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info  && current -> right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}
void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

bool Tree :: treesAreEqual ( Tree * pTree2 )
{
	if ( this == NULL && pTree2 == NULL )
		return true ;
	if ( this != NULL && pTree2 == NULL ||
	     this == NULL && pTree2 != NULL ||
	     this -> info != pTree2 -> info )
		return false;

	return this -> left -> treesAreEqual ( pTree2 -> left )  &&
	       this -> right -> treesAreEqual ( pTree2 -> right );
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{

	int arrInfo_1 [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 43, 67,
				16, 42, 44, 68 , STOP };
	int arrInfo_2 [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 43, 67,
				16, 42, 44, 68 , STOP };


	Tree * begin1 = NULL, * begin2 = NULL;
	int i = 0;

	while ( arrInfo_1 [ i ] != STOP )
		begin1 = begin1 -> additionElement ( arrInfo_1 [ i ++ ] );

	i = 0;
	while ( arrInfo_2 [ i ] != STOP )
		begin2 = begin2 -> additionElement ( arrInfo_2 [ i ++ ] );


	if ( begin1 -> treesAreEqual ( begin2 ))
		cout << "Trees are equal" << endl;
	else
		cout << "Trees aren't equal" << endl;

	begin1 -> deleteTree ();
	begin2 -> deleteTree ();
}

