#include <iostream.h>

#define STOP 11111
template < class T >
class	Tree {
	T info ;
	Tree * left , * right;
	Tree * next ;
public: Tree ( T nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL ) {
		info = nInfo; left = nLeft; right = nRight; next = NULL ; }
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( T );
	void deleteTree ();

	Tree * minElement ( );
	Tree * treeAsLinkedList ( bool );
	void printLinkedList () ;
};


template < class T >
Tree < T > * Tree < T > :: additionElement ( T newInfo )
{       
	Tree < T > * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree < T >  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info  && current -> right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN Tree < T >\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree < T >  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree < T >  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}

template < class T >
void Tree < T > :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

template < class T >
Tree < T > * Tree < T > :: minElement ( )
{
	for ( Tree < T> * current = this ; current -> left; current = current -> left )
		;
	return current ;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

template < class T >
Tree < T > * Tree < T > :: treeAsLinkedList ( bool flag  )
{
	static Tree < T > * beginLink , * Link;

	if( flag )
		beginLink = Link = this -> minElement ( );

	if( this -> left )
		this -> left -> treeAsLinkedList ( false ) ;
	Link -> next = this ;
	Link = Link -> next ;
	Link -> next  = 0 ;

	if( this -> right )
		this -> right -> treeAsLinkedList ( false ) ;

	return beginLink ;
}

template < class T >
void Tree < T > :: printLinkedList ()
{
	for ( Tree < T> * current = this ; current ; current = current -> next )
		cout << current -> info << "  ";
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{

	int arrInfo [ ] = { 40,
						20, 60,
						10, 30, 50, 70,
						5, 15, 35, 45, 65,
						13, 17, 43, 67,
						16, 42, 44, 68 , STOP };
	
	Tree < int > * begin = NULL, * linkedList;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );


	linkedList = begin -> treeAsLinkedList ( true );

	linkedList -> printLinkedList ( );

	begin -> deleteTree ();
}
