#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void deleteTree ();

	int elementLevel ( int ) ;
	int placeInLevel ( int , int );
};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}

void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

int Tree :: elementLevel ( int searchInfo )    // Non - recursive
{
	Tree * current = this ;
	int counter = - 1;
	while ( current ) {
		counter ++ ;
		if ( searchInfo == current -> info )
			return counter ;
		if ( searchInfo < current -> info )
		      current = current -> left;
		else
		     current = current -> right;
	}
	return -1 ;
}

int Tree :: placeInLevel ( int level, int searchInfo )
{
	static int currentLevel = - 1 , counter;
	if ( currentLevel == - 1 )
		counter = - 1;
	currentLevel ++ ;
	if ( this -> left  && currentLevel < level )
		this -> left -> placeInLevel ( level, searchInfo ) ;
	if ( currentLevel == level && this -> info <= searchInfo )
		counter ++ ;
	if ( this -> right  && currentLevel < level  )
		this -> right -> placeInLevel ( level, searchInfo );
	currentLevel -- ;
	return counter;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 33, 43, 47, 67,
				16, 42, 44, 68,  STOP };
	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	int searchInfo = 45 ;
	int level = begin -> elementLevel ( searchInfo );
	if ( level != -1 )
		cout << "Place  " << begin -> placeInLevel ( level , searchInfo );

	cout << endl;

	begin -> deleteTree ();
}
