#include <iostream.h>

#define STOP 11111

class	Tree {
	unsigned int info ;
	Tree * left , * right;
public: Tree ( unsigned int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	unsigned int infoOut () { return info ; }
	Tree * additionElement ( unsigned int );
	void deleteTree ();

	unsigned int  maxSumChain ( );
	void printChain ( unsigned int );
};

Tree * Tree :: additionElement ( unsigned int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}

void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////
unsigned int  Tree :: maxSumChain ( )
{
	static unsigned int currSum = 0, maxSum , lastInfo ;

	if ( currSum == 0 )
		maxSum = 0;
	currSum += this -> info ;
	if ( maxSum < currSum ) {
		maxSum = currSum ;
		lastInfo = this -> info ;
	}
	if ( this -> left )
		this -> left -> maxSumChain ();
	if ( this -> right )
		this -> right -> maxSumChain ();
	currSum -= this -> info;
	return lastInfo ;
}

void Tree :: printChain ( unsigned int infoEndChain )
{
	Tree * current = this;
	while ( current ) {
		cout << current -> info << "  " ;
		if ( current -> info == infoEndChain )
			return;
		if ( current -> info > infoEndChain )
			current = current -> left;
		else
			current = current -> right ;
	}
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	unsigned int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 25, 35, 45, 55, 65, 75,
				13, 23, 27, 37, 43, 53, 67,
				22, 24, 26, 38, 54,
				21, 39, STOP };
	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	unsigned int infoEndChain = begin -> maxSumChain ( );
	begin -> printChain ( infoEndChain );
	cout << endl;

	begin -> deleteTree ();
}
