#include <iostream.h>

#define STOP 11111
#define EMPTY  -11111
template < class T >
class	Tree {
	T info ;
	Tree * left , * right;
public: Tree ( T nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL ) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	T infoOut () { return info ; }
	Tree * additionElement ( T );
	void deleteTree ();
	int Depth ( ) ;

	void toArray ( T [ ] , int );
};

template < class T >
Tree < T > * Tree < T > :: additionElement ( T newInfo )
{       Tree < T > * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}

template < class T >
void Tree < T >:: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}
/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////
template < class T >
int Tree < T > :: Depth ( )
{
	if ( this == NULL )
		return  - 1 ;
	int depthLeft = this -> left -> Depth ();
	int depthRight = this -> right -> Depth ();
	return  depthLeft > depthRight ? depthLeft + 1 : depthRight + 1;
}

template < class T >
void Tree < T > :: toArray ( T array [ ] , int index )
{
	array [ index ] = this -> info;
	if ( this -> left )
		this -> left -> toArray ( array , 2 * index + 1 );
	if ( this -> right )
		this -> right -> toArray ( array , 2 * index + 2 );
}

template < class T >
void arrayPrint ( T array [ ] , int arrSize )
{
	int indexFirst = 0, indexLast = 0, i;
	cout << array [ 0 ];
	while ( indexLast < arrSize - 1 ) {
		indexFirst = 2 * indexFirst + 1 ;
		indexLast = 2 * indexLast + 2 ;
		if ( indexLast > arrSize - 1 )
			indexLast = arrSize - 1 ;
		
		cout << endl;
		for ( i = indexFirst ; i <= indexLast ; i ++ )
			if ( array [ i ] != EMPTY )
				cout << array [ i ] << "  ";
		
	}
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{

	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 33, 43, 47, 67,
				16, 42, 44, 68 , STOP };

	Tree < int > * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	int depth = begin -> Depth ();

	int arrSize = ( 1 << ( depth + 1 ) ) - 1 ;	// pow ( 2, depth + 1 ) - 1
	int * array = new int [ arrSize ];
	for ( i = 0; i < arrSize ; i ++ )
		array [ i ] = EMPTY ;

	begin -> toArray ( array , 0 );

	arrayPrint ( array , arrSize );

	delete [ ] array ;
	begin -> deleteTree ();
}