#include <iostream.h>

#define EMPTY -11111

template < class T >
bool isSimmetry ( T array [ ] , int arrSize )
{
	int indexFirst = 0, indexLast = 0, i, j;

	while ( indexLast < arrSize - 1 ) {
		indexFirst = 2 * indexFirst + 1 ;
		indexLast = 2 * indexLast + 2 ;
		if ( indexLast > arrSize - 1 ) {
			for ( i = 0; i <= indexLast - arrSize ; i ++ )
				if ( array [ indexFirst + i ] != EMPTY )
					return false ;
			indexFirst += i;
			indexLast = arrSize - 1 ;
		}
		for ( i = indexFirst, j = indexLast ; i < j ; i ++, j -- )
			if ( array [ i ] == EMPTY && array [ j ] != EMPTY ||
			     array [ i ] != EMPTY && array [ j ] == EMPTY )
				return false;
	}
	return true ;
}

void main()
{
	int array [ ] = {
		1,
		2, 3,
		4, 5, 6, 7,
		8, 9, EMPTY, 10, 11 , EMPTY, 12, 13,
		EMPTY, EMPTY, 14, 15, EMPTY, EMPTY, EMPTY, EMPTY, EMPTY,
			EMPTY, EMPTY, EMPTY, 16, 17       
		} ;
	if ( isSimmetry ( array , sizeof ( array ) / sizeof ( int )))
		cout << "Is simmetry\n";
	else
		cout << "Isn't symmetry\n";
}