#include <iostream.h>

bool isHeap ( int array [ ] , int arrSize )
{
	int i , leftSon, rightSon;
	for ( i = 0 ; i < arrSize - 1 ; i ++ ) {
		leftSon = 2 * i + 1 ;
		if ( leftSon < arrSize && array [ i ] < array [ leftSon ] )
			return false;
		rightSon = 2 * i + 2 ;
		if ( rightSon < arrSize && array [ i ] < array [ rightSon ] )
			return false;
	}
	return true;
}

void main()
{
	int array [ ] = {
		100,
		90, 70,
		60, 80, 20, 40,
		45, 55, 75, 65, 15, 5, 25, 35,
		13, 37, 43, 47, 23
	};

	if ( isHeap ( array , sizeof ( array ) / sizeof ( int )) ) 
		cout << "Array is Heap\n" ;
	else
		cout << "Array isn't Heap\n" ;
}
