#include <iostream.h>
template <class T >
void maxChain ( T array [ ], int arrSize )
{
	T  maxSum = array [ 0 ], currentSum;
	int  maxLength = 1, currentLength, maxStart = 0, i, j ;

	for ( i = 1; i < arrSize ; i ++ ) {
		currentSum = 0;
		currentLength = 0;
		for ( j = i; j >= 0 ; j = ( j - 1 ) / 2 ) {
			currentSum += array [ j ];
			currentLength++;
			if ( currentSum > maxSum ) {
			     maxSum = currentSum;
			     maxLength = currentLength;
			     maxStart = i;
			}
			if ( j == 0 )
				break;
		}
	}

	for ( i = maxStart ; maxLength ; i = ( i - 1 ) / 2, maxLength -- )
		cout << array [ i ] << "  " ;
}

void main()
{
	int array [ ] = {
		-20,
		80, 40,
		-70, -10, 30, -50,
		15, -25, 95, 55, 0, -85, 65, 25,
		-23, 17, 43, 57, -33
	};
	maxChain ( array, sizeof ( array ) / sizeof ( int )) ;
}
