#include <stdio.h>
#define K 4
#define M 6
#define N 8
char matr [ M ][ N ] = { { 'a' , 'w' , 'o' , 'r' , 'd' , 'b' , 'c' , 'w' },
			 { 'd' , 'o' , 'o' , 'e' , 'f' , 'h' , 'i' , 'o' },
			 { 'j' , 'r' , 'k' , 'r' , 'w' , 'l' , 'w' , 'r' },
			 { 'm' , 'd' , 'n' , 'o' , 'd' , 'o' , 'o' , 'd' },
			 { 'p' , 'q' , 'r' , 's' , 'w' , 'o' , 'r' , 'd' },
			 { 't' , 'u' , 'v' , 'w' , 'x' , 'y' , 'd' , 'd' } };
char searchWord [ K ] = { 'w' , 'o' , 'r' , 'd' };

int check ( int i, int j, int flag )
{
	int k ;
	for ( k = 0 ; k < K ; k ++ ) {
		if ( matr [ i ][ j ] != searchWord [ k ] )
			return 0;
		switch ( flag ) {
			case 1 : j ++ ; break ;
			case 2 : i ++ ; break ;
			case 3 : i ++ ; j ++ ;
		}
	}
	return 1;
}

void main ()
{
	int i, j, counter = 0;

	for ( i = 0 ; i < M ; i ++ )
		for ( j = 0 ; j < N ; j ++ ) {
			if ( j <= N - K )		  // Horizontal check
				counter += check ( i, j, 1 );
			if ( i <= M - K )       	  // Vertical check
				counter += check ( i, j, 2 );
			if ( j <= N - K && i <= M - K )   // Diagonal check
				counter += check ( i, j, 3 );
		}
	printf ( "Search Word :   %d  times" , counter);
}