#include <stdio.h>
#define M 8
#define N 10

int  matr [ M ][ N ] =
		      { { 0 , 1 , 0 , 0 , 1 , 1 , 0 , 1 , 1 , 1 },
			{ 1 , 1 , 1 , 1 , 0 , 1 , 1 , 0 , 1 , 0 },
			{ 0 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 1 },
			{ 1 , 0 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 1 },
			{ 0 , 1 , 0 , 1 , 1 , 0 , 0 , 0 , 0 , 0 },
			{ 1 , 1 , 1 , 0 , 1 , 1 , 1 , 0 , 0 , 1 },
			{ 0 , 1 , 0 , 1 , 0 , 1 , 0 , 0 , 0 , 1 },
			{ 0 , 1 , 0 , 1 , 1 , 0 , 1 , 0 , 0 , 1 } };

int check ( int i, int j, int k, int m )
{
	int ii , jj ;
	for ( ii = 0; ii < k ; ii ++ )
	for ( jj = 0; jj < m ;  jj ++ )
		if ( matr [ i + ii ][ j + jj ] )
			return 0 ;
	return 1 ;
}

void main ( )
{
	int i, j, k, m,  maxArea = 0 , startI ,startJ, sizeI, sizeJ;

	for ( i = 0 ; i < M ; i ++ )
		for ( j = 0 ; j < N  ; j ++ )
			for ( k = 1 ; k <= M - i ; k ++ )
				for ( m = ( maxArea + 1 ) / k ; m <= N - j ; m ++ )
					if ( check ( i, j , k , m ) &&
					      k * m > maxArea ) {
						maxArea = k * m;
						startI = i ;
						startJ = j ;
						sizeI = k ;
						sizeJ = m ;
					}
	printf ( "From ...[ %d ][ %d ], Size { %d , %d } : Area %d" ,
	      startI ,startJ, sizeI, sizeJ , maxArea );
}
