#include <stdio.h>                  // MAX SYMMETRIC SUB - MATRIX
#define N 8
#define M 10

int matr[N][M] = { { 1, 2, 0, 3, 9, 4, 5, 4, 6, 7 },
		{ 2, 4, 3, 5, 9, 0, 2, 5, 4, 1 },
		{ 5, 3, 6, 7, 6, 1, 9, 0, 4, 2 },
		{ 6, 9, 5, 7, 1, 2, 3, 4, 5, 0 },
		{ 8, 3, 1, 9, 2, 0, 6, 7, 8, 2 },
		{ 2, 7, 9, 0, 3, 6, 3, 4, 5, 3 },
		{ 0, 2, 5, 9, 4, 7, 4, 6, 7, 7 },
		{ 1, 7, 6, 8, 5, 8, 5, 7, 0, 6 } };

int check ( int i, int j, int k )
{
	int ii, jj;
	for ( ii = 0; ii < k ; ii++ )
	for ( jj = 0; jj < ii ;  jj ++ )
		if ( matr [ i + ii ][ j + jj ] != matr [ i + jj ][ j + ii ] )
			return 0;
	return 1;
}

void main()
{
	int i, j, k;
	int iResult = 0, jResult = 0, sizeResult = 1;
	for ( i = 0 ; i < N - sizeResult ; i++ )
		for ( j = 0; j < M - sizeResult ; j++ )
			for ( k = sizeResult + 1 ; k <= N - i && k <= M - j; k ++ ) {
				if ( check ( i, j, k ) == 0 )
					break ;
				iResult = i;
				jResult = j;
				sizeResult = k;
			}
	printf ( "Max symmetric matrix : From point [ %d ][ %d ], size  %d",
		iResult , jResult , sizeResult ) ;
}



