#include <graphics.h>
#include <stdlib.h>
#include <bios.h>

#define WIDTH 640
#define HEIGHT 480

char matr [ HEIGHT ][ WIDTH / 8];

int counter(int i, int j)
{
	int result = 0, l , k, m;
	for ( k = j - 1; k <= j + 1; k++)
	for ( m = i - 1; m <= i + 1; m++)  {
		if ( k == j &&  m == i ) continue;
		l = k % 8 - 1;
		if (l == -1) l = 7;
		if ( matr[m][k/8] & 0x1 << l) result++;
	}
	return result;
}

void main()
{
	int i, j, l, temp;
	int driver = VGA, mode = VGAHI;

	initgraph( &driver, &mode, "d:\\my_bc\\bgi");

	for ( i = 1; i < HEIGHT - 1; i++)
	for ( j = 1; j < WIDTH - 1; j++) {
		l = j % 8 - 1;
		if (l == -1) l = 7;
		if (random(20) == 1) {
			matr[i][j/8] |= 0x1 << l;
		}
	}

	while(!bioskey(1))
	{
		for ( i = 1; i < HEIGHT - 1; i++)
		for ( j = 1; j < WIDTH - 1; j++) {
			temp = counter ( i, j );
			if ( temp == 3) {
				l = j % 8 - 1;
				if (l == -1) l = 7;
				matr [i][j/8] |= 0x1 << l;
				putpixel(j, i, 15);
			}
			if (temp > 1 && temp < 5 ) continue;

			l = j % 8 - 1;
			if (l == -1) l = 7;
			matr[i][j/8] &= ~(0x1 << l);
			putpixel(j, i, 0);
		}
	}
}
