#include <stdio.h>

void MaxMinElement ( int arr [], int first , int last, int * maxIndex , int * minIndex )
{
	int localMax_1, localMax_2, localMin_1, localMin_2;
	if ( last == first ) {
		* maxIndex = * minIndex = first ;
		return ;
	}
	MaxMinElement ( arr , first, (first + last)/ 2, & localMax_1 , & localMin_1 );
	MaxMinElement ( arr , (first + last) / 2 + 1, last, & localMax_2 , & localMin_2 );
	if ( arr [ localMax_1 ] > arr [ localMax_2 ] )
		* maxIndex = localMax_1 ;
	else
		* maxIndex = localMax_2 ;
	if ( arr [ localMin_1 ] < arr [ localMin_2 ] )
		* minIndex = localMin_1 ;
	else
		* minIndex = localMin_2 ;
}
void sort ( int arr [ ], int first , int last )
{
	int minIndex , maxIndex , temp , i;
	for ( ;  first < last ; first ++ , last -- ) {
		MaxMinElement ( arr , first , last , & maxIndex , & minIndex );

		if ( first != minIndex ) {
			temp = arr [ first ];
			arr [ first ] = arr [ minIndex ] ;
			arr [ minIndex ] = temp ;
			if ( maxIndex == first )
				maxIndex = minIndex ;
		}
		if ( last != maxIndex ) {
			temp = arr [ last ];
			arr [ last ] = arr [ maxIndex ] ;
			arr [ maxIndex ] = temp ;
		}
	}
}

void main()
{
	int arr [ 10 ] = { 34, 12, 76, 45, 23, 56, 100, 68 , 98 , 7}, i;
	sort ( arr , 0, 9 );
	for ( i = 0; i < 10; i ++ )
		printf ( "%d " , arr [ i ] );
}