#include <graphics.h>
#include <math.h>
#include <conio.h>

#define  SATELLITE  8

float arrCos [ SATELLITE ], arrSin [ SATELLITE ], f = 0.3;

void circles ( float xC, float yC, float r, int n )
{
	int i;
	float fr = f * r;
	setcolor ( n * 3 );
	circle ( xC, yC, r );
	if ( n > 1 )
		for ( i = 0; i < SATELLITE ; i++ )
			circles ( xC + r * arrCos [ i ] ,
				  yC + r * arrSin [ i ] , fr , n - 1 );
}

void main()
{
	int driver = VGA, mode = VGAHI, r = 85, n = 4, i;
	float coeff = 2;
	initgraph ( &driver, &mode, "");
	for ( i = 0; i < SATELLITE ; i++ ) {
		arrCos [ i ] = coeff * cos ( i * 2 * M_PI / SATELLITE );
		arrSin [ i ] = coeff * sin ( i * 2 * M_PI / SATELLITE );
	}
	circles ( getmaxx() / 2 , getmaxy () / 2, r, n );
	getch();
	closegraph();
}

