#include <iostream.h>

int ** matrixAllocat_Init ( unsigned size , int * data )
{

	int ** ppMatr ;

	ppMatr = new int * [ size ] ;
	for ( unsigned i = 0 ; i < size ; i ++ )
		ppMatr [ i ] = new int [ size - i ] ;

	for ( i = 0 ; i < size ; i++ )
		for ( unsigned j = 0 ; j < size - i ; j ++ )
			if ( * data )
				ppMatr [ i ][ j ] = * data ++ ;
			else
				ppMatr [ i ][ j ] = 0;
	return ppMatr ;
}

void matrixPrint ( int ** ppMatr , unsigned size )
{
	for ( unsigned i = 0 ; i < size ; i++ ) {
		for ( unsigned j = 0 ; j < size - i ; j++ ) {
			 cout.width ( 4 ) ;
			 cout << ppMatr [ i ] [ j ] ;//////* ( * ( ppMatr + i ) + j ) ;
		}
		cout << endl ;
	}
}

void matrixDelete ( int ** ppMatr , unsigned size )
{
	for ( unsigned i = 0 ; i < size ; i++ )
		delete [ ] ppMatr [ i ] ;
	delete [ ]  ppMatr ;
}

void main ()
{
	int ** ppA , **ppB ;
	int sizeA = 4 , sizeB = 3 ;
	int dataA [] = { 1, 2, 3, 4, 5, 6,  7, 8, 9, 10 };

	ppA = matrixAllocat_Init ( sizeA, dataA );
	ppB = matrixAllocat_Init ( sizeB, NULL );

	matrixPrint ( ppA , sizeA );
	matrixPrint ( ppB , sizeB );

	matrixDelete ( ppA , sizeA );
	matrixDelete ( ppB , sizeB );
}
