#include <stdio.h>                 // FUNCTION ( int nElements , ... )
#include <stdarg.h>

long sum ( unsigned int n , ... )
{
   long result = 0;
   va_list myArguments;
   va_start ( myArguments, n );
   while ( n -- )
	result += va_arg ( myArguments, long );
   va_end ( myArguments );
   return result;
}

void main ( void )
{
	long a = 1111, b = 22222 , c = 333333 ;
	printf ( "%ld + %ld + %ld = %ld" , a , b , c , sum ( 3 , a , b , c ) );
}      // OUTPUT   1111 + 22222 + 333333 = 356666

