#include <iostream.h>
#include <stdarg.h>

#define STOP -111111
long sum ( long a , long b = 0, long c = 0 )
{
	return a + b + c ;
}

long sum ( int a, ... )
{
   long result = 0, temp ;
   va_list myArguments ;
   va_start ( myArguments, a );

   result = a;
   temp = va_arg ( myArguments, long );
   while ( temp != STOP ) {
	result += temp;
	temp = va_arg ( myArguments, long );
   }
   va_end ( myArguments );
   return result;
}

void main ( void )
{
	long a = 1, b = 20, c = 300 , d = 4000 , e = 50000 ;
	cout << sum ( a ) << endl ;
	cout << sum ( a , b ) << endl ;
	cout << sum ( a , b , c ) << endl ;
	cout << sum ( a , b , c , d , e , STOP ) << endl ;
}

