#include <stdarg.h>		      // Simple version of printf () function
#include <stdio.h>

void printLongDec ( unsigned long number )
{
	if ( number ) {
		printLongDec ( number / 10 );
		putchar ( number % 10 + '0' );
	}
}

void myPrintf ( char * format, ... )
{
   char * pFormat = format, * pTempChar , tempChar ;
   short tempShort;
   long tempLong ;
   va_list myArgum;
   va_start ( myArgum , format );
   while ( * pFormat ) {
	if ( * pFormat != '%' ) {
		putchar ( * pFormat );
		pFormat ++ ;
	}
	else {
		pFormat ++ ;
		switch ( * pFormat ) {
			case  'l': pFormat ++ ;
					tempLong = va_arg ( myArgum , long ) ;
					switch ( * pFormat ) {
						case 'd' : if ( tempLong < 0 ) {
									putchar ( '-' );
									tempLong = - tempLong ;
									}
						case 'u' :  printLongDec ( tempLong );
									break ;
						default : return ;
					}
					break;

			case  'd': tempShort = va_arg ( myArgum , short );
				   if ( tempShort < 0 ) {
					putchar ( '-' );
					tempShort = - tempShort ;
				   }
				   printLongDec ( tempShort );
				   break ;
			case  'u': tempShort = va_arg ( myArgum , short );
				   printLongDec ( tempShort );
				   break ;
			case  'c': tempChar = va_arg ( myArgum , char );
				   putchar ( tempChar );
				   break;

			case  's': pTempChar = va_arg ( myArgum , char * );
				   while ( * pTempChar ) {
					putchar ( * pTempChar );
					pTempChar ++ ;
				   }
		}
		pFormat ++ ;
	}
   }
   va_end ( myArgum );
}
void main ( void )
{
	long Long = -123456789;
	unsigned long uLong = 987654321 ;
	short PositiveShort = 12345, NegativeShort = - 6789 ;
	unsigned short uShort = 12345 ;

	char Char = 'z' ;
	char String [ ] = "My string" ;
	myPrintf ( " Long = %ld\n Unsigned Long = %lu\n Positive Short = %d\n\
 Negative Short = %d\n Unsigned Short = %u\n Char = %c\n String = %s\n",
		    Long, uLong, PositiveShort , NegativeShort , uShort , Char , String );
}