#include <stdarg.h>		      // Simple version of printf () function
void printOneChar ( char C )
{
	asm {   mov	ah,  02h
		mov	dl,  C
		int	21h
	}
}
void printDec ( unsigned int number )
{
	if ( number ) {
		printDec ( number / 10 );
		printOneChar ( number % 10 + '0' );
	}
}

void myPrintf ( char * format, ... )
{
   char * pFormat = format, * pTempChar , tempChar ;
   int tempInt;
   va_list myArgum;
   va_start ( myArgum , format );
   while ( * pFormat ) {
	if ( * pFormat != '%' ) {
		printOneChar ( * pFormat );
		pFormat ++ ;
	}
	else {
		pFormat ++ ;
		switch ( * pFormat ) {
			case  's': pTempChar = va_arg ( myArgum , char * );
				   while ( * pTempChar ) {
					printOneChar ( * pTempChar );
					pTempChar ++ ;
				   }
				   break;
			case  'd': tempInt = va_arg ( myArgum , int );
				   if ( tempInt < 0 ) {
					printOneChar ( '-' );
					tempInt = - tempInt ;
				   }
				   printDec ( tempInt );
				   break ;
			case  'u': tempInt = va_arg ( myArgum , int );
				   printDec ( tempInt );
				   break ;
			case  'c': tempChar = va_arg ( myArgum , char );
				   printOneChar ( tempChar );
		}
		pFormat ++ ;
	}
   }
   va_end ( myArgum );
}
void main ( void )
{
	int PositiveInt = 12345, NegativeInt = - 6789 ;
	unsigned UnsignedInt = 65432 ;
	char Char = 'z' ;
	char String [ ] = "My string" ;
	myPrintf ( "PositiveInt = %d , NegativeInt = %d , UnsignedInt = %u ,\
Char = %c , String = %s ",
		    PositiveInt , NegativeInt , UnsignedInt , Char , String );
}