//  SIMPLE  EXAMPLE  OF POINTER  and  reference TO  FUNCTION
#include<stdio.h>
int function_1 ( int a, int b )
{
	return a + b;
}

int function_2 ( int a, int b )
{
	return a - b;
}

void swap ( int ( *& rpPointFun_1 )( int , int ), int ( *& rpPointFun_2 ) ( int , int ))
{
	int ( * pointTemp )( int , int );
	pointTemp = rpPointFun_1 ;
	rpPointFun_1 = rpPointFun_2 ;
	rpPointFun_2 = pointTemp ;
}

void main()
{
	int a = 5 , b = 3 , result_1 , result_2;
	int ( * pointFun_1 )( int , int ), ( * pointFun_2 ) ( int , int );

	pointFun_1 = function_1 ;
	pointFun_2 = function_2 ;

	result_1 = pointFun_1 ( a , b ) ;
	result_2 = pointFun_2 ( a , b ) ;
	printf ( "\nUse pointFun_1 : %d   Use pointFun_2 : %d" , result_1, result_2 );

	swap ( pointFun_1 , pointFun_2 );

	result_1 = pointFun_1 ( a , b ) ;
	result_2 = pointFun_2 ( a , b ) ;
	printf ( "\nUse pointFun_1 : %d   Use pointFun_2 : %d" , result_1, result_2 );

}


