#include <stdio.h>		     
#include <string.h>                       

#define N 5

typedef struct {
	char _Char ;
	long _Long ;
} Simple ;

int compareString ( void * a ,  void * b )
{	return  strcmp ( ( char * ) a , ( char * ) b ) ;
}

int compareInteger ( void * a ,  void * b )
{	return  * ( int * ) a - * ( int * ) b ;
}

int compareField_Char ( void * a ,  void * b )
{	return (( Simple * ) a ) -> _Char  -  ( ( Simple * ) b ) -> _Char ;
}

void  bubbleSort ( void * pArray , unsigned  nElements , unsigned  sizeElement,
		      int ( * fCompare ) ( void * ,  void * ) )
{	unsigned  i , j , k ;
	char  temp , * pj , * pj1;

	for ( i = 0 ; i < nElements - 1 ; i ++ )
		for ( j = nElements - 1 ; i < j  ; j -- ) {
			pj = ( char * ) pArray + j * sizeElement ;   // elem [j]
			pj1 = pj - sizeElement ;		 // elem [j - 1]
			if ( fCompare ( pj , pj1 ) < 0 )
			    for ( k = 0 ; k < sizeElement ; k ++ ) {
				temp = pj [ k ] ;       //  swap   by bytes
				pj [ k ] = pj1 [ k ] ; // elem [j] <-> elem [j]
				pj1 [ k ] = temp ;
			    }
		}
}

void main ( )
{	int arrayInt [ N ] =  { 123 , 3, 45, 789, 78 }, i ;
	char arrayString [ N ][ 12 ] = { "father" ,  "mother" ,  "sister" , "brother" ,
					 "grandfather" };
	Simple arrayStruct [ N ] = {  { 'c' , 11        } ,
				      { 'd' , 555555555 } ,
				      { 'a' , 44444444  } ,
				      { 'e' , 2222      } ,
				      { 'b' , 3333333   }  } ;
	bubbleSort ( arrayInt , N , sizeof ( int ) , compareInteger ) ;
	for ( i = 0 ; i < N ; i ++ )
		printf ( "%d\n" , arrayInt [ i ] ) ;

	bubbleSort ( arrayString , N , sizeof ( arrayString [ 0 ] )  , compareString ) ;
	for ( i = 0 ; i < N ; i ++ )
		printf ( "%s\n", arrayString [ i ] );

	bubbleSort ( arrayStruct , N , sizeof (Simple ) , compareField_Char ) ;
	for ( i = 0 ; i < N ; i ++ )
	       printf ("%c  %ld\n", arrayStruct [ i ] . _Char, arrayStruct [ i ] . _Long ) ;
}
