#include <stdio.h>
#include <math.h>
#define N 4

struct  Segment {
	struct Point {
	     float xCoord, yCoord ;
	} left , right;
};
void main ()
{
	struct Segment arrSegments [ N ] = { 	{  { 1 , 2 } , { 3 , 4 }        } ,
						{  { - 1 , 3 }  , { 2 , 5 }     }  ,
						{  { - 6, - 9 } , { - 9 , - 5 } } ,
						{  { 5, - 6 } , { - 3 , - 8 }   }  } ;
	float squareCurrLength , squareMaxLength = 0, deltaX , deltaY ;
	int indexMax , i ;

	for ( i = 0 ; i < N ; i ++ ) {
		deltaX = arrSegments [ i ] . left . xCoord - arrSegments [ i ] . right . xCoord ;
		deltaY = arrSegments [ i ] . left . yCoord - arrSegments [ i ] . right . yCoord ;
		squareCurrLength = deltaX * deltaX + deltaY * deltaY ;
		if ( squareCurrLength > squareMaxLength ) {
			squareMaxLength = squareCurrLength ;
			indexMax = i ;
		}
	}
	printf ( "MAX Segment : { { %f , %f } , { %f , %f } }, length %f " ,
		   arrSegments [ indexMax ] . left . xCoord , arrSegments [ indexMax ] . left . yCoord ,
		   arrSegments [ indexMax ] . right . xCoord , arrSegments [ indexMax ] . right . yCoord ,
		   sqrt ( squareMaxLength ) ) ;
}
