#include <stdio.h>
#define COMPARE( a, b ) ( a ) > ( b ) ? 1 : ( a ) < ( b ) ? -1 : 0

void main ( int argc , char * argv [ ] )
{
	FILE * pFirst = fopen ( argv [ 1 ] , "r" ),
	     * pSecond = fopen ( argv [ 2 ] , "r" ),
	     * pThird = fopen ( argv [ 3 ] , "w" );
	int elemFirst , elemSecond ;

	if ( ! pFirst || ! pSecond || ! pThird ) {
		printf ( "fopen () ERROR" );
		return;
	}

	fscanf ( pFirst , "%d", & elemFirst );
	fscanf ( pSecond , "%d", & elemSecond );
	do {
		switch ( ( int ) COMPARE ( elemFirst , elemSecond ) ) {
		     case -1 :  fprintf ( pThird , "%d " , elemFirst );
				fscanf ( pFirst , "%d", & elemFirst );
				break ;
		     case 0:    fscanf ( pFirst , "%d", & elemFirst );
		     case 1:    fprintf ( pThird , "%d " , elemSecond );
				fscanf ( pSecond , "%d", & elemSecond );
		     }
	} while ( ! feof ( pFirst ) && ! feof ( pSecond )  ) ;

	switch ( ( int ) COMPARE ( elemFirst , elemSecond ) ) {
	     case -1 :  fprintf ( pThird , "%d %d " , elemFirst , elemSecond );
			break ;
	     case 0:    fprintf ( pThird , "%d " , elemFirst );
			break ;
	     case 1:    fprintf ( pThird , "%d %d " , elemSecond , elemFirst );
	}

	while ( ! feof ( pFirst ) )
		fputc ( fgetc ( pFirst ) , pThird );

	while ( ! feof ( pSecond ) )
		fputc ( fgetc ( pSecond ) , pThird );

	fcloseall ();
}