// FanView.h : interface of the CFanView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_FANVIEW_H__DA26C312_5559_11D3_9E26_0020182E9467__INCLUDED_)
#define AFX_FANVIEW_H__DA26C312_5559_11D3_9E26_0020182E9467__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const int NUM_LINES = 40;

class CFanView : public CView
{
protected: // create from serialization only
	CFanView();
	CPoint arrLefts [ NUM_LINES ] , arrRights [ NUM_LINES ] ;
	CSize VelocityLeft, VelocityRight ;
	unsigned char lastRed, signRed, lastGreen, signGreen , lastBlue , signBlue ;
	int indexFirst , indexLast , counterColor ;
	int VelocityLeftX , VelocityLeftY, 
		VelocityRightX ,VelocityRightY ;
	DECLARE_DYNCREATE(CFanView)

// Attributes
public:
	CFanDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFanView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFanView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CFanView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in FanView.cpp
inline CFanDoc* CFanView::GetDocument()
   { return (CFanDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FANVIEW_H__DA26C312_5559_11D3_9E26_0020182E9467__INCLUDED_)
