// MoveView.h : interface of the CMoveView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MOVEVIEW_H__9423DECC_57CC_11D3_9E26_0020182E9467__INCLUDED_)
#define AFX_MOVEVIEW_H__9423DECC_57CC_11D3_9E26_0020182E9467__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMoveView : public CView
{
protected: // create from serialization only
	CMoveView();
	DECLARE_DYNCREATE(CMoveView)

// Attributes
public:
	CMoveDoc* GetDocument();
///////////------------------------
protected:
	HBITMAP   hBalloonsBmp;  
	HBITMAP   hPositiveBmp;  
	HBITMAP   hNegativeBmp; 
	BOOL      flag ;
	CPoint	  LeftTopPoint ;
	CSize     rectSize , deltaMouseTopLeft;
//////////---------------------------------


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMoveView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMoveView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMoveView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MoveView.cpp
inline CMoveDoc* CMoveView::GetDocument()
   { return (CMoveDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MOVEVIEW_H__9423DECC_57CC_11D3_9E26_0020182E9467__INCLUDED_)
