#include <iostream.h>
#include <stdlib.h>
const int N = 3 ;

class Point {
	float x , y ;
public: Point ( float xx = 0 , float yy = 0 ) { x = xx; y = yy ; }
	void operator += ( const Point & A ) {  x += A.x ; y += A.y ; }
	void operator /= ( int a ) {  x /= a ; y /= a ; }
	friend ostream & operator << ( ostream & , const Point & );
};
ostream & operator << ( ostream & s , const Point & temp )
{
	s << "( " << temp.x << " , " << temp.y << " )" ;
	return s ;
}

class Vector {
	static Point From ;
	const Point To ;
public: Vector () : To ( rand () % 10, rand ( ) % 10 ) { }
	static void setFrom ( Point newFrom ) { From = newFrom ; }
	static Point getFrom () { return From ; }
	Point getTo () const { return To ; }
};
ostream & operator << ( ostream & s , const Vector & temp )
{
	s << "From: " << temp.getFrom() << "   To: " << temp.getTo() << endl;
	return s ;
}

Point Vector :: From ;  // definition ( Allocate space )

void main ( void )
{
	srand( 7 );
	Vector :: setFrom ( Point ( rand () % 10, rand ( ) % 10 ));
	Vector arrVectors [ N ] ;
	Point newFrom ;

	for ( int i = 0; i < N ; i ++ )
		cout << arrVectors [ i ];

	for ( i = 0; i < N ; i ++ )
		newFrom += arrVectors [ i ].getTo () ;
	newFrom /= N ;

	Vector :: setFrom ( newFrom );
	for ( i = 0; i < N ; i ++ )
		cout << arrVectors [ i ] ;
}
