#include <iostream.h>

class Singleton {
	int info ;
	static Singleton * pST ;
	Singleton ( int newInfo ) { info = newInfo ; }  // private constructor
	~Singleton () { } 				// private destructor
public:
	static Singleton * setObject ( int ) ;
	static void destroyObject () { if ( pST ) delete pST ; }
	void setInfo ( int newInfo ) { info = newInfo; }
	void printInfo () const { cout << info << endl ; }
} ;
Singleton * Singleton :: setObject ( int newInfo )
{
	if ( pST == NULL )
		pST = new Singleton ( newInfo );
	else
		pST -> info = newInfo ;
	return pST ;
}

Singleton * Singleton :: pST = NULL ;

void main ( void )
{
	Singleton :: setObject ( 0 );

	Singleton * pA = Singleton :: setObject ( 1 );
	Singleton * pB = Singleton :: setObject ( 2 );

	pA -> printInfo ();		//  OUTPUT   2
	pB -> printInfo ();             //  OUTPUT   2

	pA -> setInfo ( 3 );
	pA -> printInfo ();             //  OUTPUT   3
	pB -> printInfo ();             //  OUTPUT   3

	Singleton :: destroyObject ( );
}
