#include <iostream.h>

class Fraction {
	int num;
	unsigned denom;
public:
	Fraction ( int n = 0, unsigned d = 1 ) { num = n ; denom = d ; }
	operator double () const { return ( double ) num / denom; }
	operator int () const { return num / denom; }
	Fraction operator + (int n ) const{ return Fraction( n * denom + num, denom);}
	friend ostream & operator << ( ostream & , const Fraction & );
};
ostream & operator << ( ostream & s , const Fraction & temp )
{
	s << temp . num << " / " << temp. denom;
	return s ;
}

template <class X , class Y >
X operator + ( const X & x , const Y & y )
{
	return x + ( X ) y ;
}

void main()
{

	int intA = 2, intB = 5 ;
	double doubleA = 2.2222 , doubleB = 5.5555 ; 
	Fraction FractionA ( 3, 2 ) ;

	cout << intA << " + " << intB << " = " << intA + intB << endl;
					// Output  2 + 5 = 7
	cout << intA << " + " << doubleB << " = " << intA + doubleB << endl;
					// Output  2 + 5.5555 = 7.5555
	cout << doubleA << " + " << intB << " = " << doubleA + intB << endl;
					// Output  2.2222 + 5  = 7.2222
	cout << doubleA << " + " << doubleB << " = " << doubleA + doubleB << endl;
					// Output  2.2222 + 5.5555  = 7.7777
	cout << FractionA << " + " << intA << " = " << FractionA + intA << endl;
					// Output  3 / 2  + 2 = 7 / 2
	cout << intA << " + " << FractionA << " = " << intA + FractionA << endl;
					// Output  2 + 3 / 2  = 3
	cout << doubleA << " + " << FractionA << " = " << doubleA + FractionA << endl;
					// Output  2.2222 + 3 / 2  = 3.7222
}

