#include <iostream.h>

class Fraction {
	int num;
	unsigned denom;
public:
	Fraction ( int n = 0, int d = 1 ) { num = n ; denom = d ; }
	bool operator> ( const Fraction & A )  const { return num * ( signed ) A.denom > ( signed ) denom * A.num ;}
	bool operator == ( const Fraction & A ) const  { return num * A.denom == denom * A.num ;}
	bool operator > ( int a )  const { return num > ( signed )denom * a ;}
	bool operator == ( int a )  const { return num == ( signed ) denom * a ;}
};
bool operator > ( int a, const Fraction & B )
{
	if ( B > a || B == a )
		return false;
	return true ;
}
bool operator == ( int a, const Fraction & B )
{
	return B == a;
}

template <class A , class B >
char *  arraysCompare ( const A * arrA , const B * arrB , unsigned n )
{
	for ( unsigned i = 0; i < n ; i ++ ) {
		if ( arrA [ i ] == arrB [ i ] )
			continue;
		if ( arrA [ i ] > arrB [ i ] )
			return "First is large\n" ;
		else    return "First is small\n" ;
	}
	return "First is equal to second\n";
}

void main()
{
	int arrInt_1 [ 5 ] = { 2, - 3, 7, 10, - 20 },
	    arrInt_2 [ 5 ] = { 2, - 3, -7, -10, 20 };

	Fraction arrFraction_1 [ 5 ] = { Fraction ( -2 ), Fraction ( -6, 2 ),
		Fraction ( 7 , 1 ), Fraction ( 40, 4 ), Fraction ( -200, 10 ) } ,
	  arrFraction_2 [ 5 ] = { Fraction ( -4, 2 ), Fraction ( -3 ),
		Fraction ( -7 , 1 ), Fraction ( -40, 4 ), Fraction ( -20 ) } ;

	cout << arraysCompare ( arrInt_1, arrInt_2 , 5 );
	cout << arraysCompare ( arrInt_1, arrInt_2 , 2 );
	cout << arraysCompare ( arrInt_1, arrFraction_1 , 5 );
	cout << arraysCompare ( arrFraction_2, arrInt_2 , 5 );
	cout << arraysCompare ( arrFraction_1, arrFraction_2 , 5 );
	cout << arraysCompare ( arrFraction_1, arrFraction_2 , 2 );
}