#include <iostream.h>
#include <string.h>
class List {
	char info ;
	List * next;
public: List ( char nInfo , List * nNext) { info = nInfo ; next = nNext; }
	List * additionElement ( char newInfo ) { return new List ( newInfo, this ); }
	List * deleteElement () {
		if ( this ) {
			List * temp = next;
			delete this;
			return temp;
		}
		return NULL;
	}
	void print ( );

	void printReverse ( );
	void printReverseRecursive ( );
};

void List :: print ( )
{	for ( List * current = this ; current ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

void List :: printReverse ( )
{
	List * current , * last = this ;

	while ( last -> next )
		last = last -> next ;
	cout << last -> info << "  " ;

	while ( last != this ) {
		current = this ;
		while ( current -> next != last )
			current = current -> next ;
		last = current ;
		cout << last -> info << "  " ;
	}
}

void List :: printReverseRecursive ( )
{
	if ( this -> next )
		this -> next -> printReverseRecursive ( );
	cout << this -> info << "  " ;
}

void main ()
{
	List * begin = NULL ;
	char string [ ] = "abcdefgh", * pS = string + strlen ( string ) - 1;

	while ( pS >= string )
		begin = begin -> additionElement ( * pS -- );

	cout << "Linked List\n" ;
	begin -> print ( );

	begin -> printReverse ( );
	cout << endl;
	begin -> printReverseRecursive ( );

	while ( begin )
		begin = begin -> deleteElement ();
}
