#include <iostream.h>
#include <string.h>
class CircleList {
	char info ;
	CircleList * next;
public: CircleList ( char nInfo , CircleList * nNext) { info = nInfo ; next = nNext; }
	CircleList * buildCircleList ( char * );
	void deleteCircleList () ;

	void print ( );
	void insert ( CircleList * );
};

CircleList * CircleList :: buildCircleList ( char * data )
{
	CircleList * start ;
	start =  new CircleList ( * data ++ , this );
	for ( CircleList * current = start; * data ;  current = current -> next )
		current -> next = new CircleList ( * data ++ , current );
	current -> next = start ;
	return start ;
}

void CircleList :: deleteCircleList ( )
{
	CircleList * temp = this , * current = this -> next ;
	while ( current != this ) {
		delete temp;
		temp = current;
		current = current -> next ;
	}
}

void CircleList :: print ( )
{       cout << this -> info << "  ";
	for ( CircleList * current = this -> next ; current != this  ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

void  CircleList :: insert ( CircleList * begin2 )
{
	CircleList * current1 = this, * current2 = begin2;
	while ( current1 -> next != this )
	       current1 = current1 -> next ;
	while ( current2 -> next != begin2 )
	       current2 = current2 -> next ;
	current1 -> next = begin2 ;
	current2 -> next = this ;
}

void main ()
{
	CircleList * begin1 = NULL, * begin2 = NULL ;
	char string1 [ ] = "abcdefgh" , string2 [ ] = "ABCD" ;

	begin1 = begin1 -> buildCircleList ( string1 );
	begin2 = begin2 -> buildCircleList ( string2 );

	begin1 -> print ( );
	begin2 -> print ( );

	begin1 -> insert ( begin2 );
	begin1 -> print ( );

	begin1 -> deleteCircleList ( );
}