// first list:     i -> v -> r -> s -> t -> y
// second list :   u -> n -> e -> i
// string :        "university"
// after merge
// first list :   u -> n -> i -> v -> e -> r -> s -> i -> t -> y
// second list :  EMPTY

#include <iostream.h>
#include <string.h>

class List {
	char info ;
	List * next;
public: List ( char nInfo , List * nNext) { info = nInfo ; next = nNext; }
	List * additionElement ( char newInfo ) { return new List ( newInfo, this ); }
	List * deleteElement () {
		if ( this ) {
			List * temp = next;
			delete this;
			return temp;
		}
		return NULL;
	}
	void print ( );
	List * merge ( List * , char * ) ;
};
void List :: print ( )
{	for ( List * current = this ; current ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

List * List :: merge ( List * current2 , char * string )
{
	List * current1 = this, * start , * last ;

	if ( current1 -> info == * string ) {
		start = current1 ;
		last = current1;
		current1 = current1 -> next;
	}
	else {
		start = current2 ;
		last = current2;
		current2 = current2 -> next;
	}
	string ++;

	while ( current1 && current2 ) {
		if ( current1 -> info == * string ) {
			last -> next = current1;
			current1 = current1 -> next;
		}
		else {
			last -> next = current2;
			current2 = current2 -> next;
		}
		last = last -> next ;
		string ++ ;
	}
	if ( current1 )
		last -> next = current1;
	else
		last -> next = current2;

	return start ;
}

void main ()
{
	List * begin1 = NULL, * begin2 = NULL;
	char string1 [ ] ="ivrsty", * pS1 = string1 + strlen ( string1 ) - 1;
	char string2 [ ] = "unei", * pS2 = string2 + strlen ( string2 ) - 1;
	char string [ ] = "university";

	while ( pS1 >= string1 )
		begin1 = begin1 -> additionElement ( * pS1 -- );
	while ( pS2 >= string2 )
		begin2 = begin2 -> additionElement ( * pS2 -- );

	cout << "Before merge\n" ;
	begin1 -> print ( );
	begin2 -> print ( );

	begin1 = begin1 -> merge ( begin2 , string );
	begin2 = NULL ;
	cout << "After merge\n" ;
	begin1 -> print ( );

	while ( begin1 )
		begin1 = begin1 -> deleteElement ();
}
