// Two Lists :
//  b -> c -> d -> e -> f -> g -> h
//  a -> b -> f -> i -> j
// After Merge
//  a -> b -> c -> d -> e -> f -> g -> h -> i -> j
#include <iostream.h>
#include <string.h>
template < class T >
class List {
	char info ;
	List * next;
public: List ( char nInfo , List * nNext) { info = nInfo ; next = nNext; }
	List * additionElement ( char newInfo ) { return new List ( newInfo, this ); }
	List * deleteElement () {
		if ( this ) {
			List * temp = next;
			delete this;
			return temp;
		}
		return NULL;
	}
	void print ( );
	List * merge ( List * ) ;
};
template < class T >
void List < T > :: print ( )
{	for ( List < T > * current = this ; current ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}
template < class T >
List < T > * List < T > :: merge ( List * current2 )
{
	List < T > * current1 = this , * last, * first , * temp ;
	if (   this -> info < current2 -> info ) {
		if (   this -> next == NULL ) {   // uniqe element in first list
			  this -> next = current2;
			return this;
		}
		first = last = this;
		current1 = current1 -> next;
	}
	else    if (   this -> info == current2 -> info )  {
			if (   this -> next == NULL )  {
				delete this;
				return current2;
			}
			if ( current2 -> next == NULL )  {
				delete current2;
				return this;
			}
			first = last = this;
			current1 = current1 -> next;
			temp = current2 ;
			current2 = current2 -> next;
			delete temp;
		}
		else {
			if ( current2 -> next == NULL ) { // uniqe element in second list
				current2 -> next = this;
				return current2;
			}
			first = last = current2;
			current2 = current2 -> next;
		}

	while ( current1 && current2 ) {
		if ( current1 -> info < current2 -> info ) {
			last -> next = current1;
			current1 = current1 -> next;
		}
		else    if ( current1 -> info == current2 -> info )  {
				last -> next = current1;
				current1 = current1 -> next;
				temp = current2 ;
				current2 = current2 -> next;
				delete temp;
		}
			else {
				last -> next = current2;
				current2 = current2 -> next;
			}
	       last = last -> next;
	}
	if ( current1 == NULL )
		last -> next = current2;
	else
		last -> next = current1;
	return first;
}

void main ()
{
	List < char > * begin1 = NULL, * begin2 = NULL;
	char string1 [ ] ="bcdefgh", * pS1 = string1 + strlen ( string1 ) - 1;
	char string2 [ ] = "abfij", * pS2 = string2 + strlen ( string2 ) - 1;

	while ( pS1 >= string1 )
		begin1 = begin1 -> additionElement ( * pS1 -- );
	while ( pS2 >= string2 )
		begin2 = begin2 -> additionElement ( * pS2 -- );

	cout << "Before merge\n" ;
	begin1 -> print ( );
	begin2 -> print ( );

	begin1 = begin1 -> merge ( begin2 );
	begin2 = NULL ;
	cout << "After merge\n" ;
	begin1 -> print ( );

	while ( begin1 )
		begin1 = begin1 -> deleteElement ();
}
