#include <iostream.h>
#include <string.h>
class CircleList {
	char info ;
	CircleList * next;
public: CircleList ( char nInfo , CircleList * nNext) { info = nInfo ; next = nNext; }
	CircleList * buildCircleList ( char * );
	void deleteCircleList () ;

	void print ( );
	CircleList * sevenOut ( unsigned int );
};

CircleList * CircleList :: buildCircleList ( char * data )
{
	CircleList * start ;
	start =  new CircleList ( * data ++ , this );
	for ( CircleList * current = start; * data ;  current = current -> next )
		current -> next = new CircleList ( * data ++ , current );
	current -> next = start ;
	return start ;
}

void CircleList :: deleteCircleList ( )
{
	CircleList * temp = this , * current = this -> next ;
	while ( current != this ) {
		delete temp;
		temp = current;
		current = current -> next ;
	}
}

void CircleList :: print ( )
{       cout << this -> info << "  ";
	for ( CircleList * current = this -> next ; current != this  ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}

CircleList *  CircleList :: sevenOut ( unsigned int n )
{
	CircleList * begin = this, * current , * temp ;
	while ( begin -> next != begin ) {
		current = begin ;
		for ( unsigned int i = 1 ; i < n - 1 ; i ++ )
		      current = current -> next ;
		temp = current -> next ;
		current -> next = current -> next -> next ;
		delete temp;
		begin = current -> next ;
	}
	return begin ;
}

void main ()
{
	CircleList * begin = NULL ;
	char string [ ] = "abcde" ;

	begin = begin -> buildCircleList ( string );

	begin -> print ( );
	unsigned int n = 7;
	begin = begin -> sevenOut ( n );
	begin -> print ( );

	begin -> deleteCircleList ( );
}