#include <iostream.h>
#include <string.h>

template < class T >
class CircleList {
	T info ;
	CircleList * next;
public: CircleList ( T nInfo , CircleList * nNext) { info = nInfo ; next = nNext; }
	CircleList * buildCircleList ( T * );
	void deleteCircleList () ;

	void print ( );
	CircleList * sevenOut ( unsigned int );
};
template < class T >
CircleList < T > * CircleList < T > :: buildCircleList ( T * data )
{
	CircleList < T > * start ;
	start =  new CircleList < T > ( * data ++ , this );
	for ( CircleList < T > * current = start; * data ;  current = current -> next )
		current -> next = new CircleList < T > ( * data ++ , current );
	current -> next = start ;
	return start ;
}
template < class T >
void CircleList < T > :: deleteCircleList ( )
{
	CircleList < T > * temp = this , * current = this -> next ;
	while ( current != this ) {
		delete temp;
		temp = current;
		current = current -> next ;
	}
}
template < class T >
void CircleList < T > :: print ( )
{       cout << this -> info << "  ";
	for ( CircleList < T > * current = this -> next ; current != this  ; current = current -> next )
		cout << current -> info << "  ";
	cout << endl;
}
template < class T >
CircleList < T > * CircleList < T > :: sevenOut ( unsigned int n )
{
	CircleList < T > * begin = this, * current , * temp ;
	while ( begin -> next != begin ) {
		current = begin ;
		for ( unsigned int i = 1 ; i < n - 1 ; i ++ )
		      current = current -> next ;
		temp = current -> next ;
		current -> next = current -> next -> next ;
		delete temp;
		begin = current -> next ;
	}
	return begin ;
}

void main ()
{
	CircleList < char > * begin = NULL ;
	char string [ ] = "abcde" ;

	begin = begin -> buildCircleList ( string );

	begin -> print ( );
	unsigned int n = 7;
	begin = begin -> sevenOut ( n );
	begin -> print ( );

	begin -> deleteCircleList ( );
}
