//  STACK SORTING
//  Before sorting :   21 -> 3 -> 15 -> 71 -> 28 -> 13 -> 41
//  After  sorting :   3 -> 13 -> 15 -> 21 -> 28 -> 41 -> 71

#include <iostream.h>

template < class T >
class Stack {
	T info;
	Stack * next;
public: Stack ( T newInfo , Stack * newNext ) {
			info = newInfo;  next = newNext;
		}
	Stack * PUSH ( T );
	Stack * POP ();
	char infoOut () { return info ; }

	Stack * print ( ) ;
	Stack * insert ( T );
	Stack * sort ( ) ;
};

template < class T >
Stack < T > * Stack < T > :: PUSH ( T newInfo )
{
	Stack < T > * pTemp = new Stack < T > ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

template < class T >
Stack < T > * Stack < T > :: POP ( )
{
	Stack < T > * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}
template < class T >
Stack < T > * Stack < T > :: print ( )
{
	Stack < T > * pTemp = NULL, * pTop = this ;
	while ( pTop ) {
		cout <<  pTop -> info << "  ";
		pTemp = pTemp -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );
	}
	while ( pTemp ) {
		pTop = pTop -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP ( );
	}
	return pTop ;
}

template < class T >
Stack < T > * Stack < T > :: insert ( T newInfo )
{
	Stack < T > * top1 = this , * top2 = NULL;
	while ( top1 -> info < newInfo && top1 ) {
		top2 = top2 -> PUSH ( top1 -> info );
		top1 = top1 -> POP ( );
	}
	top1 = top1 -> PUSH ( newInfo );
	while ( top2 ) {
		top1 = top1 -> PUSH ( top2 -> info );
		top2 = top2 -> POP ( );
	}
	return top1;
}

template < class T >
Stack < T > * Stack < T > :: sort ( )
{
	Stack < T > * top1 = this , * top2 = NULL;
	while ( top1 ) {
		top2 = top2 -> insert ( top1 -> info );
		top1 = top1 -> POP ( );
	}
	return top2;
}

void main ()
{
	Stack < int > * pTop = NULL ;
	int Arr [ 7 ] = { 21, 3, 15, 71, 28, 13, 41 }, * pA = & Arr [ 6 ] ;

	while ( pA >= Arr )
		pTop = pTop -> PUSH ( * pA -- );

	cout << "\nBefore sorting :\n" ;
	pTop = pTop -> print ( );

	pTop = pTop -> sort ( );
	cout << "\nAfter sorting : \n";
	pTop = pTop -> print ( );

	while ( pTop )
		pTop = pTop -> POP();
}
