#include <iostream.h>
#include <string.h>

class Stack {
	char info;
	Stack * next;
public: Stack ( char newInfo , Stack * newNext ) {	
			info = newInfo;  next = newNext;
		}
	Stack * PUSH ( char );
	Stack * POP ();
	char infoOut () { return info ; }

	Stack * print ( ) ;
	Stack * isPalindrome ( bool & flag );
};


Stack * Stack :: PUSH ( char newInfo )
{
	Stack * pTemp = new Stack ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

Stack * Stack :: POP ( )
{
	Stack * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}

Stack * Stack :: print ( )
{
	Stack * pTemp = NULL, * pTop = this ;
	while ( pTop ) {
		cout <<  pTop -> info << "  ";
		pTemp = pTemp -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );
	}
	while ( pTemp ) {
		pTop = pTop -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP ( );
	}
	return pTop ;
}

Stack * Stack :: isPalindrome ( bool & flag )
{
	Stack * pFirst = NULL , * pSecond = NULL , * pTemp = this, * pReserve = NULL;

	while ( pTemp ) {
		pFirst = pFirst -> PUSH ( pTemp ->info );
		pReserve = pReserve -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP () ;
	}
	while ( pReserve ) {
		pTemp = pTemp -> PUSH ( pReserve ->info );
		pSecond = pSecond -> PUSH ( pReserve ->info );
		pReserve = pReserve -> POP ( );
	}
	while ( pFirst ) {
		if ( pFirst -> info != pSecond -> info )
			break ;
		pFirst = pFirst -> POP ( );
		pSecond = pSecond -> POP ( );
	}
	flag = pFirst == NULL ;
	return pTemp;
}

void main ()
{
	Stack * pTop = NULL ;
	char data [ ] = "abcdedcba" ;

	char * pStr = data + strlen ( data ) - 1;
	while ( pStr >= data )
		pTop = pTop -> PUSH ( * pStr -- );

	cout << "\nStack :\n" ;
	pTop = pTop -> print ( );

	bool flag ;
	pTop = pTop -> isPalindrome ( flag );
	if ( flag )
		cout << "\nis palindrome\n";
	else
		cout << "\nisn't palindrome\n";
	
	while ( pTop )
		pTop = pTop -> POP();
}