#include <iostream.h>

class Stack {
	char info;
	Stack * next;
public: Stack ( char newInfo , Stack * newNext ) {
			info = newInfo;  next = newNext;
	}
	Stack * PUSH ( char );
	Stack * POP ();
	char infoOut () { return info ; }
};


Stack * Stack :: PUSH ( char newInfo )
{
	Stack * pTemp = new Stack ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

Stack * Stack :: POP ( )
{
	Stack * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}

bool checkBalance ( char * pExpress )
{
	Stack * pTop = NULL;
	bool flag = true;
	while ( * pExpress && flag )  {
	     if ( * pExpress == '{' || * pExpress == '[' || * pExpress == '(' )
		    pTop = pTop -> PUSH ( * pExpress );
	     if ( * pExpress == '}' || * pExpress == ']' || * pExpress == ')' )
			//// '(' = 40 , ')' = 41 , '[' = 91 , ']' = 93 , '{' = 123 , '}' = 125
			if ( pTop && abs ( * pExpress - pTop -> infoOut () ) <= 2 )
				pTop = pTop -> POP ( );
			else
				flag = false ;
	     pExpress ++;
	}
	if ( pTop )
		flag = false ;
	while ( pTop )                 		      	// Memory free
		pTop = pTop -> POP ( );

	return flag;
}

void main ( void )
{
	char expression [ ] = "[ a * ( b + 1 ) ] -  { [ c - 2 ] * ( d + ( 3 - ( e + { f * [ 4 / ( g + 5 ) ] } ) ) ) }";

	if ( checkBalance ( expression ) )
		cout << "Statement OK" << endl;
	else
		cout << "Statement isn't correct" << endl;
}
