#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL ) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void deleteTree ();

	int depth ( ) ;
	int Depth ( ) ;
};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}
void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

int Tree :: depth ( )
{
	static int maxDepth, currDepth = - 1;
	if ( currDepth == - 1 )
		maxDepth = - 1 ;
	currDepth ++;
	if ( maxDepth < currDepth )
		maxDepth = currDepth;
	if ( this -> left )
		this -> left -> depth ( ) ;
	if ( this -> right )
		this-> right -> depth ( );
	currDepth --;
	return maxDepth;
}

int Tree :: Depth ( )
{
	if ( this == NULL )
		return  - 1 ;
	int depthLeft = this -> left -> Depth ();
	int depthRight = this -> right -> Depth ();
	return  depthLeft > depthRight ? depthLeft + 1 : depthRight + 1;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{

	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 33, 43, 47, 67,
				16, 42, 44, 68 , STOP };

	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	cout << "depth is " << begin -> depth () << endl;
	cout << "Depth is " << begin -> Depth () << endl;

	begin -> deleteTree ();
}