#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void deleteTree ();

	void pathTwoElements ( int , int );
};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}

void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void Tree :: pathTwoElements ( int firstInfo, int secondInfo )
{
	int array1 [ 20 ], array2 [ 20 ] ;	// Tree depth < 20
	int counter1 = -1, counter2 = -1, i = 0 ;

	Tree * current = this ;
	while ( current ) {
		counter1 ++ ;
		array1 [ counter1 ] = current -> info ;
		if ( firstInfo == current -> info )
			break ;
		if ( firstInfo < current -> info )
		      current = current -> left;
		else
		     current = current -> right;
	}
	if ( current == NULL )
		return ;
	for ( current = this ; current ;  ) {
		counter2 ++ ;
		array2 [ counter2 ] = current -> info ;
		if ( secondInfo == current -> info )
			break ;
		if ( secondInfo < current -> info )
		      current = current -> left;
		else
		     current = current -> right;
	}
	if ( current == NULL )
		return ;

	while ( array1 [ i ] == array2 [ i ] )
		i ++ ;
	i -- ;

	for (  ; counter1 > i ; counter1 -- )
		cout << array1 [ counter1 ] << "  " ;
	for (  ; i <= counter2 ; i ++ )
		cout << array2 [ i ] << "  " ;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 33, 43, 47, 67,
				16, 42, 44, 68,  STOP };
	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	int firstInfo = 16 , secondInfo = 35;
	begin -> pathTwoElements ( firstInfo, secondInfo );
	cout << endl;

	begin -> deleteTree ();
}
