#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void InorderPrint ( );

	Tree * father ( int ) ;
	void deleteBranch ();
	Tree * searchAndDeleteBranch ( int );
};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXISTS IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}

void Tree :: InorderPrint ( )
{
	if ( this -> left )
		this -> left -> InorderPrint ( );
	cout << this -> info << ' ';
	if ( this -> right )
		this -> right -> InorderPrint ( );
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

Tree * Tree :: father ( int searchInfo )
{
	Tree * current = this ;
	while ( current ) {
		if ( searchInfo == current -> info )
			break;
		if ( searchInfo < current -> info ) {
		      if ( searchInfo == current -> left -> info )
			      return current;
		      current = current -> left;
		}
		else {
		     if ( searchInfo == current -> right -> info )
			      return current;
		     current = current -> right;
		}
	}
	return NULL;
}

void Tree :: deleteBranch ()
{
	if ( this -> left )
		this -> left -> deleteBranch ();
	if ( this -> right )
		this -> right -> deleteBranch ();
	delete this;
}
Tree * Tree :: searchAndDeleteBranch ( int searchInfo )
{
	if ( this -> info == searchInfo ) {
		this -> deleteBranch () ;
		return NULL ;
	}
	Tree * father = this -> father ( searchInfo );
	if ( father == NULL ) {
		cout << "\nElement " << searchInfo << " not found";
		return this;
	}
	if ( father -> left -> info == searchInfo ) {
		father -> left -> deleteBranch ();
		father -> left = NULL;
	}
	else {
		father -> right -> deleteBranch ();
		father -> right = NULL ;
	}
	return this ;
}


/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 65,
				13, 17, 43, 47, 63,
				16, 42, 44, 48, 64, STOP };
	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	begin -> InorderPrint ( );
	cout << endl;

	int searchInfo = 60;
	begin = begin -> searchAndDeleteBranch ( searchInfo );
	if ( begin ) {
		begin -> InorderPrint ( );
		begin -> deleteBranch ();
	}
	else
		cout << "Whool tree is deleted\n" ;
}
