#include <iostream.h>

#define STOP 11111
template < class T >
class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( T nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	T infoOut () { return info ; }
	Tree * additionElement ( T );
	void deleteTree ();
	void InorderPrint ( );

	int Depth ( );
	Tree * maxLeftBranch ( );

};

template < class T >
Tree < T > * Tree < T >:: additionElement ( T newInfo )
{       Tree < T > * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}

template < class T >
void Tree < T >:: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

template < class T >
void Tree < T >:: InorderPrint ( )
{
	if ( this -> left )
		this -> left -> InorderPrint ( );
	cout << this -> info << ' ';
	if ( this -> right )
		this -> right -> InorderPrint ( );
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

template < class T >
int Tree < T >:: Depth ( )
{
	if ( this == NULL )
		return  - 1 ;
	int depthLeft = this -> left -> Depth ();
	int depthRight = this -> right -> Depth ();
	return  depthLeft > depthRight ? depthLeft + 1 : depthRight + 1;
}

template < class T >
Tree < T > * Tree < T > :: maxLeftBranch ( )
{					// Non - recursive
	Tree < T > * current, * pMax ;
	int maxCounter = -1, counter ;

	for ( current = this ; current -> right; current = current -> right ) {
		counter = current -> left -> Depth ();

		if ( counter > maxCounter ) {
		      pMax = current -> left ;
		      maxCounter = counter;
		}
	}
	return pMax ;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				15, 25, 45, 55, 65, 75,
				13, 23, 43, 53, 57, 67, 73, 77,
				42, 44, 48, 52, 56, 62, 64, 66, 72, 76,
				41, 61, 71, STOP };
	Tree <int > * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	Tree < int > * result = begin -> maxLeftBranch ( );
	result -> InorderPrint ( );

	begin -> deleteTree ();
}
