#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void deleteTree ();
	void InorderPrint ( );

	unsigned int branchCounter ( unsigned int );
	void allBranchesFixedWeight ( unsigned int );
};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}
void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}
void Tree :: InorderPrint ( )
{
	if ( this -> left )
		this -> left -> InorderPrint ( );
	cout << this -> info << ' ';
	if ( this -> right )
		this -> right -> InorderPrint ( );
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

unsigned int Tree :: branchCounter ( unsigned int count )
{
	if ( this -> left )
		count = this -> left -> branchCounter ( count );
	count ++;
	if ( this -> right )
		count = this -> right -> branchCounter ( count );
	return count;
}

void Tree :: allBranchesFixedWeight ( unsigned int N )
{
	if ( this -> left )
		this -> left -> allBranchesFixedWeight ( N );

	unsigned int counter = this -> branchCounter ( 0 ) ;
	if ( counter == N )  {
		this -> InorderPrint ( );
		cout << endl;
	}

	if ( this -> right )
		this -> right -> allBranchesFixedWeight ( N );
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				15, 25, 45, 55, 65, 75,
				13, 23, 43, 47, 53, 57, 63, 67,
				12, 14, 42, 52, 56,
				41, STOP };
	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	unsigned int N = 5;
	begin -> allBranchesFixedWeight ( N );

	begin -> deleteTree ();
}
