#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void deleteTree ();

	int degenerateCounter ( );
	Tree * maxDegenerateSearch ( int & );
	void degeneratePrint ( ) ;

};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}
void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

int Tree :: degenerateCounter ( )  	// Non - recursive
{
	Tree * current = this;
	int counter = 1;
	while  ( current -> left || current -> right ) {
		if ( current -> left && current -> right )
			return - 1;
		if ( current -> left )
			current = current -> left ;
		else
			current = current -> right ;
		counter ++ ;
	}
	return counter ;
}

Tree * Tree :: maxDegenerateSearch ( int & maxLength )
{
	static Tree * pMaxDegenerate ;
	int  currentLength ;

	if ( this -> left == NULL && this -> right != NULL ||
	     this -> left != NULL && this -> right == NULL ) {
		currentLength = this -> degenerateCounter ( );
		if ( currentLength > maxLength ) {
			maxLength = currentLength ;
			pMaxDegenerate  = this ;
			return pMaxDegenerate ;
		}
	}

	if ( this -> left )
		 this -> left -> maxDegenerateSearch ( maxLength );
	if ( this -> right )
		 this -> right -> maxDegenerateSearch ( maxLength ) ;

	return pMaxDegenerate ;
}


void Tree:: degeneratePrint ( )      		// Non - recursive
{
	Tree * current = this ;
	while ( current ) {
		cout << current -> info << "  " ;
		if ( current -> left )
			current = current -> left;
		else
			current = current -> right ;
	}
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 35, 45, 55, 65,
				13, 33, 43, 53, 67,
				12, 32, 44, 68,
				11, 31, STOP };
	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	int maxDegenerateLength = 0;
	Tree * result = begin -> maxDegenerateSearch ( maxDegenerateLength );
	result -> degeneratePrint ();

	begin -> deleteTree ();
}
